'
'   $Id: Nagios3Multiline.vb,v 1.2 2009/03/16 09:23:13 ww Exp $
'
Imports Microsoft.VisualBasic
Imports System.Text

Public Class Nagios3Multiline
    Dim Line1Text As String
    Dim Line1PerfData As String
    Dim OutputText As New StringBuilder
    Dim PerfDataText As New StringBuilder

    Dim _Nagios3Compatibility As Boolean
    Public WriteOnly Property Nagios3Compatibility() As Boolean
        Set(ByVal value As Boolean)
            _Nagios3Compatibility = value
        End Set
    End Property

    Public Sub AddText(ByVal Value As String)
        If _Nagios3Compatibility Then
            Value = Value.Replace("<b>", "").Replace("</b>", "")
            Value = Value.Replace("<i>", "")
        End If
        '--- achtung bei der ersten Zeile muss ein CR-LF weggenommen werden (zumindest fr nag3comp)
        If Line1Text = "" Then
            If Value.EndsWith(vbLf) Then
                Value = Value.Remove(Value.LastIndexOf(vbLf), 1)
            End If
            Line1Text = Value
        Else
            OutputText.Append(Value)
        End If
    End Sub
    Public Sub AddLine(ByVal Value As String)
        AddText(Value & vbLf)
    End Sub
    '
    '--- change the first status text line to something else (e.g. summary which cannot be added before)
    '   only meaningfull if used wiht Nagios3 comp. (e.g. disks summary with v1.3.3)
    Public Sub SetLine1Text(ByVal s As String)
        If Not _Nagios3Compatibility Then Exit Sub
        Line1Text = s
    End Sub
    Public Sub AddPerfData(ByVal value As String)
        If _Nagios3Compatibility Then
            If Line1PerfData = "" Then
                Line1PerfData = value
            Else
                If Trim(value) <> "" Then
                    If PerfDataText.Length = 0 Then
                        PerfDataText.Append(value)
                    Else
                        PerfDataText.Append(vbLf & value)
                    End If
                End If
            End If
        Else
            PerfDataText.Append(" " & value)
        End If
    End Sub
    Public ReadOnly Property Text() As String
        Get
            Dim s As String
            s = Line1Text & vbLf & OutputText.ToString
            If s.EndsWith(vbLf) Then
                s = s.Remove(s.LastIndexOf(vbLf), 1)
            End If
            If Not _Nagios3Compatibility Then
                s = s.Replace(vbLf, "<br>")
            End If
            Return s
        End Get
    End Property
    Public ReadOnly Property Perfdata() As String
        Get
            Dim s As String
            s = Line1PerfData & vbLf & PerfDataText.ToString
            If s.EndsWith(vbLf) Then
                s = s.Remove(s.LastIndexOf(vbLf), 1)
            End If
            If Not _Nagios3Compatibility Then
                s = s.Replace(vbLf, "<br>")
            End If
            Return s
        End Get
    End Property
    Public ReadOnly Property TextLength() As Integer
        Get
            Return OutputText.Length
        End Get
    End Property
    Public ReadOnly Property PerfDataLength() As Integer
        Get
            Return PerfDataText.Length
        End Get
    End Property
    Public ReadOnly Property ResultString() As String
        Get
            If _Nagios3Compatibility Then
                ResultString = Line1Text & "|" & Line1PerfData
                If OutputText.Length > 0 Or PerfDataText.Length > 0 Then
                    ResultString = ResultString & vbLf & OutputText.ToString & "|" & PerfDataText.ToString
                End If
            Else
                ResultString = Me.Text.ToString & "|" & Me.Perfdata.ToString
            End If
        End Get
    End Property
End Class
