'
'   $Id: Service1.vb,v 1.11 2009/04/13 17:24:25 ww Exp $
'
Imports System.Web
Imports System.Web.Services
Imports System

#If VS2003 Then
<WebService(Namespace:="http://nagios-wsc/")> _
Public Class Service1
#Else
<WebService(Namespace:="http://nagios-wsc/")> _
<WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
<Global.Microsoft.VisualBasic.CompilerServices.DesignerGenerated()> _
Public Class Service1
#End If
    Inherits System.Web.Services.WebService

#If VS2003 Then
    Private Const wsc_version As String = "nagios-wsc v1.3.4 VS2003"
#Else
    Private Const wsc_version As String = "nagios-wsc v1.3.4 VS2005"
#End If

    Private Const RET_OK As Integer = 0
    Private Const RET_WARN As Integer = 1
    Private Const RET_CRIT As Integer = 2
    Private Const RET_UNKNOWN As Integer = 3
    Private Const DEF_QUERY_TIMEOUT As Integer = 30     ' Seconds

    Private Nagios3Compatibility As Boolean = (GetAppSetting("Nagios3Output") = 1)

    '=======================
    ' next section for code compatibility VS2003/2005 only
    '=======================
#Region " Web Services Designer Generated Code "
#If VS2003 Then

Public Sub New()
    MyBase.New()

    'This call is required by the Web Services Designer.
    InitializeComponent()

    'Add your own initialization code after the InitializeComponent() call

End Sub

'Required by the Web Services Designer
Private components As System.ComponentModel.IContainer

'NOTE: The following procedure is required by the Web Services Designer
'It can be modified using the Web Services Designer.  
'Do not modify it using the code editor.
<System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
    components = New System.ComponentModel.Container()
End Sub

Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
    'CODEGEN: This procedure is required by the Web Services Designer
    'Do not modify it using the code editor.
    If disposing Then
        If Not (components Is Nothing) Then
            components.Dispose()
        End If
    End If
    MyBase.Dispose(disposing)
End Sub
#End If
#End Region
    '=======================
    '  v1.2 methods developed by Wolfgang Wagner
    '=======================
    <WebMethod(Description:="This method shows the current version of the web-service")> Public Function version() As String
        Dim ReturnMsg As String = wsc_version
        Return "OK: " & ReturnMsg
    End Function
    <WebMethod(Description:="This method checks the age of files")> Public Function fileage(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = filespec,warncrit,options
        '   warning, critical: datediff; possible formats m,h,d
        '   options: [/newer|/older] /warn
        ' defaults: : warncrit 1d; /older
        ' ...... Remark: Windows2000 WMI does not support LIKE operator => no star convention supported!

        Dim QueryWhere As String = ""
        Dim ReturnCode As Integer = RET_UNKNOWN
        Dim ReturnMsg As String = ""
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim obj As Object
            Dim Age As DateTime
            Const IDX_FILENAME As Integer = 0
            Const IDX_WARN As Integer = 1
            Const IDX_OPTIONS As Integer = 2

            Dim param_temp As String = param & ",,,"
            Dim myarr() As String = param_temp.Split(",")

            Dim warning_val As DateTime
            Dim ServerName As String = ""
            Dim DriveLetter As String = ""
            Dim Path As String = ""
            Dim BaseName As String = ""
            Dim Extension As String = ""
            Dim ShareName As String = ""
            Dim FailIfOlder As Boolean = True
            Dim WarningIfFailed As Boolean = False
            Try
                If myarr(IDX_FILENAME) = "" Then Throw New Exception("Filename not optional")
                Call parseFileName(myarr(IDX_FILENAME), ServerName, ShareName, DriveLetter, Path, BaseName, Extension)
                warning_val = ParseTimeDiff(myarr(IDX_WARN), Now().AddDays(-1))
                If InStr(LCase(myarr(IDX_OPTIONS)), "/newer") > 0 Then FailIfOlder = False
                If InStr(LCase(myarr(IDX_OPTIONS)), "/warn") > 0 Then WarningIfFailed = True
            Catch e As Exception
                Return "Error converting parameters: " & e.Message
            End Try

            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "warning_value: '" & warning_val & "')....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"
                Return res_str
            Else
                res_str = ""
            End If

            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2:CIM_DataFile", options, ErrString)
            If scope Is Nothing Then Return ErrString

            Dim SearchOperatorExtension As String = "="
            Dim SearchOperatorBaseName As String = "="
            If Extension.IndexOf("*") > -1 Then
                SearchOperatorExtension = "LIKE"
            End If
            If BaseName.IndexOf("*") > -1 Then
                SearchOperatorBaseName = "LIKE"
            End If

            QueryWhere = "drive = '" & DriveLetter & ":'" & _
                " and path = '" & Path.Replace("\", "\\") & "'"
            If (BaseName <> "") Then
                QueryWhere = QueryWhere & " and Filename " & SearchOperatorBaseName & "  '" & BaseName.Replace("*", "%") & "'"
            End If
            If (Extension <> "") Then
                QueryWhere = QueryWhere & " and extension " & SearchOperatorExtension & " '" & Extension.Replace("*", "%") & "'"
            End If
            oq = New System.Management.ObjectQuery("Select FileName, Extension, LastModified from CIM_DataFile where " & QueryWhere)
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())
            '   Dim output As String = ""
            ReturnMsg = "age of " & BaseName & "." & Extension
            ReturnCode = RET_OK
            For Each obj In mos.Get()
                Age = WMIDateStringToDate(obj("LastModified"))
                If FailIfOlder And Age.CompareTo(warning_val) < 0 Then
                    ReturnMsg = obj("FileName") & "." & obj("Extension") & " is older then " & warning_val.ToString(System.Globalization.CultureInfo.CurrentCulture.DateTimeFormat.UniversalSortableDateTimePattern)
                    ReturnCode = RET_CRIT
                    Exit For
                ElseIf Not FailIfOlder And Age.CompareTo(warning_val) > 0 Then
                    ReturnMsg = obj("FileName") & "." & obj("Extension") & " is newer then " & warning_val
                    ReturnCode = RET_CRIT
                    Exit For
                End If
            Next

            If ReturnCode = RET_CRIT And WarningIfFailed Then ReturnCode = RET_WARN
            Select Case ReturnCode
                Case RET_OK
                    ReturnMsg = "OK; " & ReturnMsg
                Case RET_WARN
                    ReturnMsg = "Warning; " & ReturnMsg
                Case RET_CRIT
                    ReturnMsg = "Critical; " & ReturnMsg
                Case RET_UNKNOWN
                    ReturnMsg = "UNKNOWN; " & ReturnMsg
            End Select

        Catch e As Exception
            Return "Result: UNKNOWN; Unhandled exception: " & e.ToString & " using query=" & QueryWhere
        End Try
        Return "Result: " & ReturnMsg
    End Function
    <WebMethod(Description:="This method checks orccurences of a filepattern")> Public Function filecount(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = filespec,warncrit,options
        '   warning, critical: count of files allowed
        ' defaults: : 0,0
        ' ...... Remark: Windows2000 WMI does not support LIKE operator => no star convention supported!

        Dim QueryWhere As String = ""
        Dim ReturnCode As Integer = RET_UNKNOWN
        Dim ReturnMsg As String = ""
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim obj As Object
            Const IDX_FILENAME As Integer = 0
            Const IDX_WARN As Integer = 1
            Const IDX_CRIT As Integer = 2

            Dim param_temp As String = param & ",0,0,"
            Dim myarr() As String = param_temp.Split(",")

            Dim warning_val As Integer
            Dim critical_val As Integer
            Dim dummy_pr As Integer
            Dim ServerName As String = ""
            Dim DriveLetter As String = ""
            Dim Path As String = ""
            Dim BaseName As String = ""
            Dim Extension As String = ""
            Dim ShareName As String = ""
            Try
                If myarr(IDX_FILENAME) = "" Then Throw New Exception("Filename not optional")
                Call parseFileName(myarr(IDX_FILENAME), ServerName, ShareName, DriveLetter, Path, BaseName, Extension)
                warning_val = parsevalue(myarr(IDX_WARN), dummy_pr, 1)
                critical_val = parsevalue(myarr(IDX_CRIT), dummy_pr, 1)
                If critical_val = 0 Then critical_val = warning_val
            Catch e As Exception
                Return "Error converting parameters: " & e.Message
            End Try

            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "warning_value: '" & warning_val & "')....."
                res_str = res_str & "critical_val: '" & critical_val & "')....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"
                Return res_str
            Else
                res_str = ""
            End If

            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2:CIM_DataFile", options, ErrString)
            If scope Is Nothing Then Return ErrString

            Dim SearchOperatorExtension As String = "="
            Dim SearchOperatorBaseName As String = "="
            If Extension.IndexOf("*") > -1 Then
                SearchOperatorExtension = "LIKE"
            End If
            If BaseName.IndexOf("*") > -1 Then
                SearchOperatorBaseName = "LIKE"
            End If

            QueryWhere = "drive = '" & DriveLetter & ":'" & _
                " and path = '" & Path.Replace("\", "\\") & "'" & _
                " and extension " & SearchOperatorExtension & " '" & Extension.Replace("*", "%") & "'" & _
                " and Filename " & SearchOperatorBaseName & "  '" & BaseName.Replace("*", "%") & "'"
            oq = New System.Management.ObjectQuery("Select FileName, Extension, LastModified from CIM_DataFile where " & QueryWhere)
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())
            ReturnCode = RET_OK
            Dim NbOfFiles As Integer = 0
            For Each obj In mos.Get()
                NbOfFiles = NbOfFiles + 1
            Next

            ReturnMsg = NbOfFiles & " files found"

            Dim perfdata As String
            perfdata = "|nbfiles=" & NbOfFiles & ";" & warning_val & ";" & critical_val & ";;"
            ReturnMsg = ReturnMsg & perfdata

            If NbOfFiles > warning_val Then ReturnCode = RET_WARN
            If NbOfFiles > critical_val Then ReturnCode = RET_CRIT
            Select Case ReturnCode
                Case RET_OK
                    ReturnMsg = "OK; " & ReturnMsg
                Case RET_WARN
                    ReturnMsg = "Warning; " & ReturnMsg
                Case RET_CRIT
                    ReturnMsg = "Critical: " & ReturnMsg
                Case RET_UNKNOWN
                    ReturnMsg = "UNKNOWN: " & ReturnMsg
            End Select

        Catch e As Exception
            Return "Result:  UNKNOWN: Unhandled exception: " & e.ToString & " using query=" & QueryWhere
        End Try
        Return "Result: " & ReturnMsg
    End Function
    <WebMethod(Description:="This method checks the size of files")> Public Function filesize(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = name of directory,warning,critical
        '   positive values: warning/critical if count above watermark 
        '   negative values: warning/critical if count below watermark
        '   Default: 0,0 (critical if file exists)
        ' ...... Remark: Windows2000 WMI does not support LIKE operator => no star convention supported!

        Dim QueryWhere As String = ""
        Dim ReturnCode As Integer = RET_UNKNOWN
        Dim ReturnMsg As String = ""
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim obj As Object
            Dim dummy_pr As Boolean
            Dim size As Double
            Const IDX_FILENAME As Integer = 0
            Const IDX_WARN As Integer = 1
            Const IDX_CRIT As Integer = 2

            Dim param_temp As String = param & ",0,0"
            Dim myarr() As String = param_temp.Split(",")

            If myarr(IDX_FILENAME) = "" Then
                ' Error: Filename must be used
            End If

            Dim warning_val As Double = 0
            Dim critical_val As Double = 0
            Dim ServerName As String = ""
            Dim DriveLetter As String = ""
            Dim Path As String = ""
            Dim BaseName As String = ""
            Dim Extension As String = ""
            Dim ShareName As String = ""

            Try
                warning_val = parsevalue(myarr(IDX_WARN), dummy_pr, 1)
                critical_val = parsevalue(myarr(IDX_CRIT), dummy_pr, 1)
                If critical_val = 0 Then critical_val = warning_val
                Call parseFileName(myarr(IDX_FILENAME), ServerName, ShareName, DriveLetter, Path, BaseName, Extension)
            Catch e As Exception
                Return "Error converting parameters: " & e.Message
            End Try

            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "warning_value: '" & warning_val & "')....."
                res_str = res_str & "critical_value: '" & critical_val & "')....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"
                Return res_str
            Else
                res_str = ""
            End If

            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2:CIM_DataFile", options, ErrString)
            If scope Is Nothing Then Return ErrString

            Dim SearchOperatorExtension As String = "="
            Dim SearchOperatorBaseName As String = "="
            If Extension.IndexOf("*") > -1 Then
                SearchOperatorExtension = "LIKE"
            End If
            If BaseName.IndexOf("*") > -1 Then
                SearchOperatorBaseName = "LIKE"
            End If

            QueryWhere = "drive = '" & DriveLetter & ":'" & _
                " and path = '" & Path.Replace("\", "\\") & "'" & _
                " and extension " & SearchOperatorExtension & " '" & Extension.Replace("*", "%") & "'" & _
                " and Filename " & SearchOperatorBaseName & "  '" & BaseName.Replace("*", "%") & "'"
            oq = New System.Management.ObjectQuery("Select FileName, Extension, FileSize from CIM_DataFile where " & QueryWhere)
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())
            '   Dim output As String = ""
            Dim Cnt As Integer = 0
            Dim NewRetCode As Integer
            Dim ReturnSize As Double
            Dim ReturnFileName As String = ""
            ReturnCode = RET_OK
            For Each obj In mos.Get()
                Cnt = Cnt + 1
                size = Convert.ToDouble(obj("FileSize"))
                If warning_val >= 0 And size > warning_val Then NewRetCode = RET_WARN
                If warning_val < 0 And size < System.Math.Abs(warning_val) Then NewRetCode = RET_WARN
                If critical_val >= 0 And size > critical_val Then NewRetCode = RET_CRIT
                If critical_val < 0 And size < System.Math.Abs(critical_val) Then NewRetCode = RET_CRIT
                ' increase Level if currently lower
                If ReturnCode <> RET_CRIT And NewRetCode = RET_CRIT Then
                    ReturnCode = RET_CRIT
                    ReturnSize = size
                    ReturnFileName = obj("FileName") & "." & obj("Extension")
                End If
                If ReturnCode = RET_OK And NewRetCode <> RET_OK Then
                    ReturnCode = NewRetCode
                    ReturnSize = size
                    ReturnFileName = obj("FileName") & "." & obj("Extension")
                End If
            Next

            If ReturnCode = RET_OK And Cnt = 0 Then
                ReturnMsg = "No Files found"
            Else
                If ReturnCode > 0 Then ReturnMsg = ReturnFileName & " size=" & SizeHumanReadable(ReturnSize)
            End If
            Select Case ReturnCode
                Case RET_OK
                    Return "Result: OK: " & ReturnMsg
                Case RET_WARN
                    Return "Result: Warning: " & ReturnMsg
                Case RET_CRIT
                    Return "Result: Critical: " & ReturnMsg
                Case RET_UNKNOWN
                    Return "Result: UNKNOWN: " & ReturnMsg
            End Select

        Catch e As Exception
            Return "Result: UNKNOWN: Unhandled exception: " & e.ToString & " using query=" & QueryWhere
        End Try
        Return "Result: UNKNOWN: " & ReturnMsg
    End Function
    '=======================
    '  additional methods developed by Konstantin Timokhin
    '=======================
    <WebMethod(Description:="This method checks free amount of physical memory and pagefile")> Public Function memory(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = memwarning, memcritical, vmemwarning, vmemcritical
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim obj As Object

            Dim param_temp As String = param + ",,,,"
            Dim myarr() As String = param_temp.Split(",")

            Dim check_memwarning As Double
            Dim check_memwarning_percents As Boolean = True
            If myarr(0) <> "" Then
                check_memwarning = parsevalue(myarr(0), check_memwarning_percents, 1024L)
            End If
            Dim check_memcritical As Double
            Dim check_memcritical_percents As Boolean = True
            If myarr(1) <> "" Then
                check_memcritical = parsevalue(myarr(1), check_memcritical_percents, 1024L)
                If myarr(0) = "" Then
                    check_memwarning = check_memcritical * 2
                    check_memwarning_percents = check_memcritical_percents
                End If
            ElseIf myarr(0) <> "" Then
                check_memcritical = Val(check_memwarning / 2)
                check_memcritical_percents = check_memwarning_percents
            End If

            Dim check_vmemwarning As Double
            Dim check_vmemwarning_percents As Boolean = True
            If myarr(2) <> "" Then
                check_vmemwarning = parsevalue(myarr(2), check_vmemwarning_percents, 1024L)
            End If
            Dim check_vmemcritical As Double
            Dim check_vmemcritical_percents As Boolean = True
            If myarr(3) <> "" Then
                check_vmemcritical = parsevalue(myarr(3), check_vmemcritical_percents, 1024L)
                If myarr(3) = "" Then
                    check_vmemwarning = check_vmemcritical * 2
                    check_vmemwarning_percents = check_vmemcritical_percents
                End If
            ElseIf myarr(2) <> "" Then
                check_vmemcritical = Val(check_vmemwarning / 2)
                check_vmemcritical_percents = check_vmemwarning_percents
            End If

            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"
                Return res_str
            Else
                res_str = ""
            End If

            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2", options, ErrString)
            If scope Is Nothing Then Return ErrString

            oq = New System.Management.ObjectQuery("Select FreePhysicalMemory,FreeVirtualMemory,TotalVirtualMemorySize from Win32_OperatingSystem")
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())
            Dim availablePMem, availableVMem, totalVMem, totalPMem As Double

            For Each obj In mos.Get()
                availablePMem = System.Convert.ToDouble(obj("FreePhysicalMemory").ToString) * 1024
                availableVMem = System.Convert.ToDouble(obj("FreeVirtualMemory").ToString) * 1024
                totalVMem = System.Convert.ToDouble(obj("TotalVirtualMemorySize").ToString) * 1024
            Next

            oq = New System.Management.ObjectQuery("Select * from Win32_ComputerSystem")
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())
            For Each obj In mos.Get()
                totalPMem = System.Convert.ToDouble(obj("TotalPhysicalMemory").ToString)
                totalPMem = totalPMem
            Next

            Dim freePMem, freeVMem, checkvalue As Long
            '            Dim oStr As String = ""
            Dim iscritical As Boolean = False
            Dim iswarning As Boolean = False

            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility
            ResultStr.AddLine(" ")

            If myarr(0) <> "" Or myarr(1) <> "" Then
                freePMem = CInt(availablePMem / totalPMem * 100)
                If check_memcritical_percents = True Then checkvalue = freePMem Else checkvalue = availablePMem
                If check_memcritical > checkvalue Then
                    ResultStr.AddLine("<b>Physical Mem: " & SizeHumanReadable(availablePMem) & "/" & SizeHumanReadable(totalPMem) & " (" & freePMem & "%)</b>")
                    iscritical = True
                Else
                    If check_memwarning_percents = True Then checkvalue = freePMem Else checkvalue = availablePMem
                    If check_memwarning > checkvalue Then
                        ResultStr.AddLine("<i>Physical Mem: " & SizeHumanReadable(availablePMem) & "/" & SizeHumanReadable(totalPMem) & " (" & freePMem & "%)</i>")
                        iswarning = True
                    Else
                        ResultStr.AddLine("Physical Mem: " & SizeHumanReadable(availablePMem) & "/" & SizeHumanReadable(totalPMem) & " (" & freePMem & "%)")
                    End If
                End If
            End If
            If myarr(3) <> "" Or myarr(4) <> "" Then
                freeVMem = CInt(availableVMem / totalVMem * 100)
                'If ResultStr.TextLength <> 0 Then ResultStr.AddText("<br>")
                If check_vmemcritical_percents = True Then checkvalue = freeVMem Else checkvalue = availableVMem
                If check_vmemcritical > checkvalue Then
                    ResultStr.AddLine("<b>Virtual Mem: " & SizeHumanReadable(availableVMem) & "/" & SizeHumanReadable(totalVMem) & " (" & freeVMem & "%)</b>")
                    iscritical = True
                Else
                    If check_vmemwarning_percents = True Then checkvalue = freeVMem Else checkvalue = availableVMem
                    If check_vmemwarning > checkvalue Then
                        ResultStr.AddLine("<i>Virtual Mem: " & SizeHumanReadable(availableVMem) & "/" & SizeHumanReadable(totalVMem) & " (" & freeVMem & "%)</i>")
                        iswarning = True
                    Else
                        ResultStr.AddLine("Virtual Mem: " & SizeHumanReadable(availableVMem) & "/" & SizeHumanReadable(totalVMem) & " (" & freeVMem & "%)")
                    End If
                End If
            End If
            ' TODO: Muss noch verbessert werden; Wenn Angabe in Prozent, dann stimmen die perfdata-Werte fr warn/crit nicht
            '       es gibt keine Default-Werte fr warning/critical!

            Dim perfdata As String
            '--- physical memory
            perfdata = "'Free PMem'=" & availablePMem & "B;"
            '            perfdata = perfdata & SizeHumanReadable(check_memwarning) & ";" & SizeHumanReadable(check_memcritical) & ";"
            perfdata = perfdata & ";;"
            perfdata = perfdata & "0;" & totalPMem
            '--- virtual memory
            perfdata = perfdata & " 'Free VMem'=" & availableVMem & "B;"
            '            perfdata = perfdata & SizeHumanReadable(check_vmemwarning) & ";" & SizeHumanReadable(check_vmemcritical) & ";"
            perfdata = perfdata & ";;"
            perfdata = perfdata & "0;" & totalVMem
            ResultStr.AddPerfData(perfdata)

            If iscritical Then
                Return "Result: Memory Critical" & ResultStr.ResultString
            ElseIf iswarning Then
                Return "Result: Memory Warning" & ResultStr.ResultString
            Else
                Return "Result: Memory Ok" & ResultStr.ResultString
            End If
        Catch e As Exception
            Return "Result: UNKNOWN; Unhandled exception: " & e.ToString
        End Try
    End Function

    <WebMethod(Description:="This method checks a NT Events for the defined period of time")> Public Function ntevents(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = logfiles(splited by "|"),sourcenames(splited by "|"),eventcodes(splited by "|"),period(in minutes)
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim obj As Object

            Dim param_temp As String = param + ",,,,"
            Dim myarr() As String = param_temp.Split(",")

            Dim check_logfiles As String = myarr(0)
            Dim check_sources As String = myarr(1)
            Dim check_eventcodes As String = myarr(2)
            Dim check_period As Integer = 1
            If myarr(3) <> "" Then
                check_period = CInt(myarr(3).ToString)
            End If

            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "Log files to check: '" & myarr(0) & "'....."
                res_str = res_str & "Sources to check: '" & myarr(1) & "'....."
                res_str = res_str & "Event codes to check: '" & myarr(2) & "'....."
                res_str = res_str & "Check period: '" & check_period.ToString & "' min....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"

                If myarr(0) = "" Then
                    res_str = res_str & "All log files are used....."
                End If
                If myarr(1) = "" Then
                    res_str = res_str & "All sources are used....."
                End If
                If myarr(2) = "" Then
                    res_str = res_str & "All event codes are used....."
                End If
                If myarr(3) = "" Then
                    res_str = res_str & "Check period defaulted to 1 min....."
                End If
                Return res_str
            Else
                res_str = ""
            End If

            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2:Win32_NTEventLog", options, ErrString)
            If scope Is Nothing Then Return ErrString

            Dim QueryWhere As String = ""
            Dim tempWhere As String = ""

            If check_logfiles <> "" Then
                QueryWhere = "(" & splitforquery(check_logfiles, "LogFile") & ")"
            End If

            If check_sources <> "" Then
                If QueryWhere <> "" Then QueryWhere = QueryWhere & " And "
                QueryWhere = QueryWhere & "(" & splitforquery(check_sources, "SourceName") & ")"
            End If

            If check_eventcodes <> "" Then
                If QueryWhere <> "" Then QueryWhere = QueryWhere & " And "
                QueryWhere = QueryWhere & "(" & splitforquery(check_eventcodes, "EventCode") & ")"
            End If

            If QueryWhere <> "" Then QueryWhere = QueryWhere & " And "

            QueryWhere = QueryWhere & "(TimeGenerated >= '" & nteventdatetime(TimeZone.CurrentTimeZone.ToUniversalTime(DateAdd("n", -check_period, Now)))
            QueryWhere = QueryWhere & "' And TimeGenerated <= '" & nteventdatetime(TimeZone.CurrentTimeZone.ToUniversalTime(Now)) & "')"


            'Return "Select * from Win32_NTLogEvent where " & QueryWhere
            oq = New System.Management.ObjectQuery("Select LogFile,SourceName,EventCode,EventType,Message,TimeGenerated from Win32_NTLogEvent where " & QueryWhere)
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())
            '   Dim output As String = ""
            '            Dim ntevents_str As String = ""
            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility
            ResultStr.AddLine(" ")

            Dim warning As Integer = 0
            Dim critical As Integer = 0
            Dim tstr As String
            '  Dim i_threshold As Long
            '  i_threshold = Val(param) * 1024 * 1024 ' convert megabytes to bytes
            Dim ecount As Integer = 0
            For Each obj In mos.Get()
                tstr = obj("LogFile") & ";" & obj("SourceName") & ";" & System.Convert.ToString(obj("EventCode")) & ";" & Left(obj("Message"), 50)
                If obj("EventType") = 1 Then
                    ecount = ecount + 1
                    critical = critical + 1
                    If ecount < 6 Then
                        'If ResultStr.TextLength > 0 Then ResultStr.AddText("<br>")
                        ResultStr.AddLine("<b>E;" & tstr & "</b>")
                    End If
                ElseIf obj("EventType") = 2 Then
                    ecount = ecount + 1
                    warning = warning + 1
                    If ecount < 6 Then
                        '                        If ResultStr.TextLength > 0 Then ResultStr.AddText("<br>")
                        ResultStr.AddLine("W;" & tstr)
                    End If
                    'Else
                    '	ntevents_str = ntevents_str & "I;" & tstr
                End If
            Next

            If critical > 0 Then
                Return "Result: NTEventLog Critical" + ResultStr.ResultString
            ElseIf warning > 0 Then
                Return "Result: NTEventLog Warning" + ResultStr.ResultString
            Else
                Return "Result: NTEventLog Ok" + ResultStr.ResultString
            End If
        Catch e As Exception
            Return "Result UNKNOWN: Unhandled exception: " & e.ToString
        End Try
    End Function

    <WebMethod(Description:="This method checks a special NT Event(s) for the defined period of time")> Public Function ntevent(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = eventtypes(splited by "|"),
        '		  logfiles(splited by "|"),
        '		  sourcenames(splited by "|"),
        '		  eventcodes(splited by "|"),
        '		  searchstring,
        '		  period(in minutes),
        '		  type of returned state if found (i,w,c),
        '		  type of returned state if not found (i,w,c)
        '         optinal switches /W2K: Windows2000 compatible search for message strings (do not use "LIKE"-operator)
        Dim QueryWhere As String = ""

        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim obj As Object

            Dim param_temp As String = param + ",,,,,,"
            Dim myarr() As String = param_temp.Split(",")

            Dim check_types As String = myarr(0)
            Dim check_logfiles As String = myarr(1)
            Dim check_sources As String = myarr(2)
            Dim check_eventcodes As String = myarr(3)
            Dim check_searchstring As String = myarr(4)
            Dim check_period As Integer = 1
            Dim check_W2Kcompatible As Boolean = False
            If myarr(5) <> "" Then
                check_period = CInt(myarr(5).ToString)
            End If
            Dim check_returnstate_found As String = "c"
            If myarr(6) <> "" Then
                check_returnstate_found = myarr(6)
            End If
            Dim check_returnstate_notfound As String = "i"
            If myarr(7) <> "" Then
                check_returnstate_notfound = myarr(7)
            End If
            If UCase(myarr(8)) = "/W2K" Then
                check_W2Kcompatible = True
            End If

            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "Event types to check: '" & check_types & "'....."
                res_str = res_str & "Log files to check: '" & check_logfiles & "'....."
                res_str = res_str & "Sources to check: '" & check_sources & "'....."
                res_str = res_str & "Event codes to check: '" & check_eventcodes & "'....."
                res_str = res_str & "Searched string: '" & myarr(4) & "'....."
                res_str = res_str & "Check period: '" & check_period.ToString & "' min....."
                res_str = res_str & "State returned when found: '" & check_returnstate_found & "'....."
                res_str = res_str & "State returned when not found: '" & check_returnstate_notfound & "'....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"
                res_str = res_str & "Windows2000 compatible search: " & check_W2Kcompatible

                If check_types = "" Then
                    res_str = res_str & "All event types are used....."
                End If
                If check_logfiles = "" Then
                    res_str = res_str & "All log files are used....."
                End If
                If check_sources = "" Then
                    res_str = res_str & "All sources are used....."
                End If
                If check_eventcodes = "" Then
                    res_str = res_str & "All event codes are used....."
                End If
                If check_searchstring = "" Then
                    res_str = res_str & "No search string are used....."
                End If
                If myarr(5) = "" Then
                    res_str = res_str & "Check period defaulted to 1 min....."
                End If
                If myarr(6) = "" Then
                    res_str = res_str & "State when found defaulted to " & check_returnstate_found & " min....."
                End If
                If myarr(7) = "" Then
                    res_str = res_str & "State when not found defaulted to " & check_returnstate_notfound & " min....."
                End If
                Return res_str
            Else
                res_str = ""
            End If

            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2:Win32_NTEventLog", options, ErrString)
            If scope Is Nothing Then Return ErrString

            If check_logfiles <> "" Then
                QueryWhere = "(" & splitforquery(check_logfiles, "LogFile") & ")"
            End If

            If check_types <> "" Then
                If QueryWhere <> "" Then QueryWhere = QueryWhere & " And "
                QueryWhere = QueryWhere & "(" & splitforquery(check_types, "EventType") & ")"
            End If

            If check_sources <> "" Then
                If QueryWhere <> "" Then QueryWhere = QueryWhere & " And "
                QueryWhere = QueryWhere & "(" & splitforquery(check_sources, "SourceName") & ")"
            End If

            If check_eventcodes <> "" Then
                If QueryWhere <> "" Then QueryWhere = QueryWhere & " And "
                QueryWhere = QueryWhere & "(" & splitforquery(check_eventcodes, "EventCode") & ")"
            End If

            If Not check_W2Kcompatible Then
                If check_searchstring <> "" Then
                    If QueryWhere <> "" Then QueryWhere = QueryWhere & " And "
                    QueryWhere = QueryWhere & "Message LIKE '%" & check_searchstring & "%'"
                End If
            End If
            If QueryWhere <> "" Then QueryWhere = QueryWhere & " And "

            QueryWhere = QueryWhere & "(TimeGenerated >= '" & nteventdatetime(TimeZone.CurrentTimeZone.ToUniversalTime(DateAdd("n", -check_period, Now)))
            '            QueryWhere = QueryWhere & "')"
            QueryWhere = QueryWhere & "' And TimeGenerated <= '" & nteventdatetime(TimeZone.CurrentTimeZone.ToUniversalTime(Now)) & "')"

            Dim sSelect As String
            sSelect = "Select LogFile,SourceName,EventCode,User,Message,EventType  from Win32_NTLogEvent where " & QueryWhere

            oq = New System.Management.ObjectQuery(sSelect)
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())
            '   Dim output As String = ""
            'Dim ntevents_str As String = ""
            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility
            ResultStr.AddLine(" ")

            Dim tstr As String = ""
            Dim warning As Integer = 0
            Dim critical As Integer = 0
            '  Dim i_threshold As Long
            '  i_threshold = Val(param) * 1024 * 1024 ' convert megabytes to bytes
            Dim ecount As Integer = 0
            Dim mosCount As Integer = 0
            Dim fSearchstringFound As Boolean = False
            For Each obj In mos.Get()
                tstr = obj("message") & "; Searching for: " & check_searchstring
                ' Win2000 does not support LIKE; there we have to check for occurences ourself
                ' due to that we do have to count mosCount as well (W2K3: mosCount == mos.count(); W2K: mosCount <= mos.count())
                If check_W2Kcompatible Then
                    fSearchstringFound = System.Convert.ToString(obj("message")).ToUpper().IndexOf(check_searchstring.ToUpper()) > -1
                Else
                    fSearchstringFound = True
                End If
                If fSearchstringFound Then
                    mosCount = mosCount + 1
                    tstr = obj("LogFile") & ";" & obj("SourceName") & ";" & System.Convert.ToString(obj("EventCode")) & ";" & System.Convert.ToString(obj("User")) & ";" & Left(obj("Message"), 80)
                    Console.WriteLine(obj("SourceName") & ";" & System.Convert.ToString(obj("EventCode")) & ";" & obj("Message") & ";")
                    ecount = ecount + 1
                    If ecount > 5 Then Exit For ' max. event-count for output reached
                    If obj("EventType") = 1 Then
                        critical = critical + 1
                        'If ResultStr.TextLength > 0 Then ResultStr.AddText("<br>")
                        ResultStr.AddLine("<b>E;" & tstr & "</b>")
                    ElseIf obj("EventType") = 2 Then
                        warning = warning + 1
                        'If ResultStr.TextLength > 0 Then ResultStr.AddText("<br>")
                        ResultStr.AddLine("W;" & tstr)
                    Else
                        ResultStr.AddLine("I;" & tstr)
                    End If
                End If
            Next

            If mosCount = 0 Then
                Select Case check_returnstate_notfound
                    Case "c"
                        Return "Result: NTEvent Critical; No events found"
                    Case "w"
                        Return "Result: NTEvent Warning; No events found"
                    Case Else
                        Return "Result: NTEvent Ok; No events found"
                End Select
            Else
                Select Case check_returnstate_found
                    Case "c"
                        Return "Result: NTEvent Critical" + ResultStr.ResultString
                    Case "w"
                        Return "Result: NTEvent Warning" + ResultStr.ResultString
                    Case Else
                        Return "Result: NTEvent Ok" + ResultStr.ResultString
                End Select
            End If
            mos = Nothing
        Catch e As Exception
            Return "Result: UNKNOWN: Unhandled exception: " & e.ToString & "<BR>Using query: " & QueryWhere
        End Try
    End Function

    <WebMethod(Description:="This method checks a number of processes compares to the threshold value, supplied in integer number")> Public Function process(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = warning/critical level to use - in integer
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim param_temp As String = param + ",-1,-1"
            Dim myarr() As String = param_temp.Split(",")
            Dim process_to_check As String = myarr(0).ToString
            If process_to_check = "" Then process_to_check = "svchost.exe"
            Dim warning_val As Long = myarr(1)
            Dim critical_val As Long = myarr(2)

            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "Process to check: '" & process_to_check & "'....."
                res_str = res_str & "warning_value: '" & warning_val & "'(int)....."
                res_str = res_str & "critical_value: '" & critical_val & "'(int)....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"

                If param = "" Then
                    res_str = res_str & "Process defaulted to 'svchost.exe'....."
                End If
                If myarr(1) = -1 Then
                    res_str = res_str & "Warning value defaulted to -1....."
                End If
                If myarr(2) = -1 Then
                    res_str = res_str & "Critical value defaulted to -1....."
                End If
                Return res_str
            Else
                res_str = ""
            End If

            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2:Win32_Process", options, ErrString)
            If scope Is Nothing Then Return ErrString

            oq = New System.Management.ObjectQuery("Select Name from Win32_Process where name = '" & process_to_check & "'")
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())
            '   Dim output As String = ""
            Dim process_str As String = ""
            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility
            ResultStr.AddLine(" ")

            Dim processes_number As Integer = mos.Get().Count

            ResultStr.AddPerfData("nbprocs=" & processes_number & ";" & warning_val & ";" & critical_val & ";;")

            If processes_number = 0 Then
                ResultStr.AddText("Process '" & process_to_check & "' is not running")
                Return "Result: Process Critical" & ResultStr.ResultString
            Else
                ResultStr.AddText("Number of instances of '" & process_to_check & "' is " & processes_number)
                If processes_number < critical_val Then
                    Return "Result: Process Critical" + ResultStr.ResultString
                ElseIf processes_number < warning_val Then
                    Return "Result: Process Warning" + ResultStr.ResultString
                Else
                    Return "Result: Process Okay" + ResultStr.ResultString
                End If
            End If
        Catch e As Exception
            Return "Result: UNKNOWN: Unhandled exception: " & e.ToString
        End Try
    End Function

    '=====================
    '
    '=====================


    <WebMethod(Description:="This method checks a single, local disk of a remote server and compares to the threshold value, supplied in megabytes")> Public Function disk(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = drive,warning/critical level to use - in MEGABYTES
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""
            Dim IDX_DISK As Integer
            Dim IDX_WARNING As Integer
            Dim IDX_CRITICAL As Integer

            IDX_DISK = 0
            IDX_WARNING = 1
            IDX_CRITICAL = 2

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim obj As Object
            Dim free As Double
            Dim size As Double

            ' Default = 1MB Warning, 0,5 MB Critical; unusual but compatible to the original service
            Dim param_temp As String = param + ",-1,-1"
            Dim myarr() As String = param_temp.Split(",")
            Dim disk_to_check As String = myarr(IDX_DISK).ToString
            If disk_to_check = "" Then disk_to_check = "C"

            Dim warning_val As Long = 0
            Dim warning_use_pr As Boolean = False
            Try
                warning_val = parsevalue(myarr(IDX_WARNING), warning_use_pr, 1024L * 1024L)
                If warning_val = -1 Then warning_val = 1
            Catch e As Exception
                Return "Error converting parameters: " & e.Message
            End Try

            Dim critical_val As Long = 0
            Dim critical_use_pr As Boolean = False

            Try
                critical_val = parsevalue(myarr(IDX_CRITICAL), critical_use_pr, 1024L * 1024L)
                If critical_val < 0 Then
                    critical_val = warning_val / 2
                    critical_use_pr = warning_use_pr
                End If
            Catch e As Exception
                Return "Error converting parameters: " & e.Message
            End Try

            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "Disk to check: '" & disk_to_check & "'....."
                If warning_use_pr Then
                    res_str = res_str & "warning_value: '" & warning_val & "'(%)....."
                Else
                    res_str = res_str & "warning_value: '" & warning_val & "'(bytes)....."
                End If
                If critical_use_pr Then
                    res_str = res_str & "critical_value: '" & critical_val & "'(%)....."
                Else
                    res_str = res_str & "critical_value: '" & critical_val & "'(bytes)....."
                End If
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"

                If param = "" Then
                    res_str = res_str & "Disk defaulted to C drive....."
                End If
                If Val(myarr(IDX_WARNING)) = -1 Then
                    res_str = res_str & "Warning value defaulted to 1MB....."
                End If
                If Val(myarr(IDX_CRITICAL)) = -1 Then
                    res_str = res_str & "Critical value defaulted (to half of warning value)....."
                End If
                Return res_str
            Else
                res_str = ""
            End If

            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2:Win32_LogicalDisk", options, ErrString)
            If scope Is Nothing Then Return ErrString
            oq = New System.Management.ObjectQuery("Select DeviceID,size,freespace from Win32_LogicalDisk where drivetype = 3 and deviceid = '" & disk_to_check & ":'")
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())
            '   Dim output As String = ""
            'Dim disk_str As String = ""
            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility

            Dim low_space As Boolean = False
            Dim very_low As Boolean = False
            Dim freepr As Integer
            Dim tstr As String
            For Each obj In mos.Get()
                If ResultStr.TextLength > 0 Then ResultStr.AddLine("")
                size = System.Convert.ToDouble(obj("size"))
                free = System.Convert.ToDouble(obj("freespace"))

                If size > 0 Then ' on non-mounted cluster disks: size is zero
                    freepr = Format(((100 * free) / size), "standard")
                    tstr = obj("DeviceID") & SizeHumanReadable(free) & "/" & SizeHumanReadable(size) & " (" & freepr & "% free)"

                    If warning_use_pr Then
                        If freepr < warning_val Then
                            low_space = True
                            tstr = "<b>" & tstr & "</b>"
                        End If
                    Else
                        If free < warning_val Then
                            low_space = True
                            tstr = "<b>" & tstr & "</b>"
                        End If
                    End If

                    If critical_use_pr Then
                        If freepr < critical_val Then very_low = True
                    Else
                        If free < critical_val Then very_low = True
                    End If
                    ResultStr.AddLine(tstr)

                End If
            Next

            Dim perfdata As String
            perfdata = "freeperc=" & freepr & "%;"
            If warning_use_pr Then
                perfdata = perfdata & warning_val
            Else
                perfdata = perfdata & Format(((100 * warning_val) / size), "0")
            End If
            perfdata = perfdata & ";"
            If critical_use_pr Then
                perfdata = perfdata & critical_val
            Else
                perfdata = perfdata & Format(((100 * critical_val) / size), "0")
            End If
            perfdata = perfdata & ";;"

            ResultStr.AddPerfData(perfdata)

            If very_low Then
                Return "Result: Disk Critical;" + ResultStr.ResultString
            Else
                If low_space Then
                    Return "Result: Disk Warning;" + ResultStr.ResultString
                Else
                    Return "Result: Disk Okay;" + ResultStr.ResultString
                End If
            End If
        Catch e As Exception
            Return "Result UNKNOWN: Unhandled exception: " & e.ToString
        End Try

    End Function

    <WebMethod(Description:="This method checks all local disks of a remote server and compares to the threshold value, supplied in megabytes")> Public Function disks(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = warning/critical level to use - in MEGABYTES,percentage...,alloweddisks

        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim obj As Object
            Dim free As Double
            Dim size As Double

            '!!!!!!!!!!!!!!!!!!!
            '! modified by KT
            '!!!!!!!!!!!!!!!!!!!
            Dim param_temp As String = param
            If param_temp = "" Then param_temp = "-1"
            Dim myarr() As String = param_temp.Split(",")

            Dim warning_val As Long = 20
            Dim warning_use_pr As Boolean = True
            If myarr(0) <> "-1" Then
                warning_val = parsevalue(myarr(0), warning_use_pr, 1024L * 1024L)
            End If

            Dim critical_val As Long = warning_val / 2
            Dim critical_use_pr As Boolean = True
            Dim UseAsExceptList As Boolean = False
            Dim allowed_disks As String = ""
            Try
                If myarr.GetUpperBound(0) > 0 Then  ' 2nd param is entered
                    critical_val = parsevalue(myarr(1), critical_use_pr, 1024L * 1024L)
                End If
                If myarr.GetUpperBound(0) > 1 Then  ' 3rd param is entered
                    If Left(myarr(2), 8) = "exclude:" Then
                        UseAsExceptList = True
                        myarr(2) = myarr(2).Substring(8, Len(myarr(2)) - 8)
                    End If
                    allowed_disks = myarr(2)
                End If
                '!!!!!!!!!!!!!!!!!!            If param_temp = "" Then param_temp = "-1"
            Catch e As Exception
                Return "Error converting parameters: " & e.Message
            End Try
            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "warning_value: '" & warning_val & "'(bytes)....."
                res_str = res_str & "critical_value: '" & critical_val & "'(bytes)....."
                res_str = res_str & "disks for check: '" & allowed_disks & "'....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"

                If myarr(0) = -1 Then
                    res_str = res_str & "Warning value defaulted to 1MB....."
                End If
                If myarr.GetUpperBound(0) = 0 Then
                    res_str = res_str & "Critical value defaulted (to half of warning value)....."
                End If
                Return res_str
            Else
                res_str = ""
            End If

            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2:Win32_LogicalDisk", options, ErrString)
            If scope Is Nothing Then Return ErrString
            oq = New System.Management.ObjectQuery("Select DeviceID,size,freespace from Win32_LogicalDisk where drivetype = 3")
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())
            '   Dim output As String = ""
            'Dim disk_str As String = ""
            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility
            '---- Attention: Due to later summary-line this is added in any case!
            ResultStr.AddLine(" ")

            Dim low_space As Boolean = False
            Dim very_low As Boolean = False
            '  Dim i_threshold As Long
            '  i_threshold = Val(param) * 1024 * 1024 ' convert megabytes to bytes
            '!!!!!!!!!!!!!!!!!!!!!!!
            '! modified by KT
            '!!!!!!!!!!!!!!!!!!!!!!!
            Dim allowed_disks_arr As Array = Nothing
            Dim disk_proceed As Boolean
            Dim freepr As Integer
            Dim Cnt As Integer
            If allowed_disks <> "" Then allowed_disks_arr = Split(allowed_disks, "|")
            Dim tstr As String
            Dim tSummary As String = ""
            For Each obj In mos.Get()
                disk_proceed = True
                If allowed_disks <> "" Then
                    If UseAsExceptList Then
                        If Array.IndexOf(allowed_disks_arr, obj("DeviceID")) <> -1 Then disk_proceed = False
                    Else
                        If Array.IndexOf(allowed_disks_arr, obj("DeviceID")) = -1 Then disk_proceed = False
                    End If
                End If
                If disk_proceed = True Then
                    Cnt = Cnt + 1
                    size = System.Convert.ToDouble(obj("size"))
                    free = System.Convert.ToDouble(obj("freespace"))

                    If size > 0 Then ' on non-mounted cluster disks: size is zero
                        freepr = Format(((100 * free) / size), "standard")

                        tstr = obj("DeviceID") & SizeHumanReadable(free) & "/" & SizeHumanReadable(size) & " (" & freepr & "% free)"

                        If warning_use_pr Then
                            If freepr < warning_val Then
                                low_space = True
                                tstr = "<b>" & tstr & "</b>"
                                tSummary = tSummary & obj("DeviceID") & "(" & freepr & "%),"
                            End If
                        Else
                            If free < warning_val Then
                                low_space = True
                                tstr = "<b>" & tstr & "</b>"
                                tSummary = tSummary & obj("DeviceID") & "(" & freepr & "%),"
                            End If
                        End If

                        If critical_use_pr Then
                            If freepr < critical_val Then very_low = True
                        Else
                            If free < critical_val Then very_low = True
                        End If

                        ResultStr.AddLine(tstr)
                    End If
                End If
                '------
                Dim perfdata As String
                perfdata = "Free-" & obj("DeviceId") & "=" & freepr & "%;"
                If warning_use_pr Then
                    perfdata = perfdata & warning_val
                Else
                    perfdata = perfdata & Format(((100 * warning_val) / size), "0")
                End If
                perfdata = perfdata & ";"
                If critical_use_pr Then
                    perfdata = perfdata & critical_val
                Else
                    perfdata = perfdata & Format(((100 * critical_val) / size), "0")
                End If
                perfdata = perfdata & ";;"

                ResultStr.AddPerfData(perfdata)

                '------
            Next
            If Me.Nagios3Compatibility Then
                If tSummary <> "" Then
                    ' Delete trailing comma
                    ResultStr.SetLine1Text(tSummary.Remove(tSummary.LastIndexOf(","), 1))
                End If
            End If

            If very_low Then
                Return "Result: Disk(s) Critical; " + ResultStr.ResultString
            Else
                If low_space Then
                    Return "Result: Disk(s) Warning; " + ResultStr.ResultString
                ElseIf Cnt = 0 Then
                    Return "Result: Unknown: No disks to check!"
                Else
                    Return "Result: Disk(s) Okay" + ResultStr.ResultString
                End If
            End If

        Catch e As Exception
            Return "Result UNKNOWN: Unhandled exception: " & e.ToString
        End Try

    End Function
#If Not VS2003 Then

    '=======================
    '  additional developed by LUONG Olivier
    '=======================
    <WebMethod(Description:="This method checks the queue disk")> Public Function disk_queue(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = comma separated utilisation
        '           drive letter list: C,E,F : "c" if none
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            'Dim res_str As String = ""
            Dim i As Integer

            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility
            ResultStr.AddLine(" ")

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim param_temp As String = param
            If param_temp = "" Then param_temp = "C"

            Dim drive() As String = param_temp.Split(",")
            Dim queue(drive.GetUpperBound(0)) As String
            For i = drive.getlowerbound(0) To drive.getUpperbound(0)
                drive(i) = Strings.Left(drive(i), 1).ToUpperInvariant()
                queue(i) = "-1"
            Next i

            'New CultureInfo("en-US", False))

            If debug_flag Then
                ResultStr.AddText("Server: '" & server & "'.....")
                ResultStr.AddText("Param value passed: '" & param & "'.....")
                ResultStr.AddText("WMI username: '" & options.Username & "'.....Notes:")

                Return ResultStr.ResultString
            End If

            Dim query As String = "Select Name,CurrentDiskQueueLength FROM Win32_PerfFormattedData_PerfDisk_LogicalDisk"

            Dim obj As Object
            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2", options, ErrString)
            If scope Is Nothing Then Return ErrString
            oq = New System.Management.ObjectQuery(query)
            mos = New System.Management.ManagementObjectSearcher(scope, oq)





            'Dim arQueue As Array = Array.CreateInstance(GetType(String), totalDisk)
            For Each obj In mos.Get()
                If Not IsNothing(obj("Name")) Then
                    Dim letter As String = Strings.Left(obj("Name").ToString, 1).ToUpperInvariant()
                    Dim position As Integer = Array.BinarySearch(drive, letter)
                    If position >= 0 Then
                        If Not IsNothing(obj("CurrentDiskQueueLength")) Then
                            queue(position) = CInt(obj("CurrentDiskQueueLength")).ToString
                        End If
                        ResultStr.AddText(drive(position) & "=" & queue(position) & ",")
                        'res_str = res_str & obj("PercentProcessorTime").ToString & "%"
                    Else
                        ' returned null value
                        'res_str = res_str & "<null>"
                    End If
                End If
            Next

            Dim perfdata As String = ""
            Dim unknown As Boolean = False
            For i = drive.GetLowerBound(0) To drive.GetUpperBound(0)
                Dim datasource As String = "QUEUE_" & drive(i)

                perfdata = perfdata & datasource.ToLowerInvariant() & "=" & queue(i) & ";;;; "
                If String.Compare(queue(i), "-1") = 0 Then
                    unknown = True
                End If
            Next i
            ResultStr.AddPerfData(perfdata)

            If unknown Then
                Return "Result: DRIVE UNKNOWN" + ResultStr.ResultString
            End If
            Return "Result: QUEUE(s) Okay" + ResultStr.ResultString

        Catch e As Exception
            Return "Result UNKNOWN: Unhandled exception: " & e.ToString
        End Try
    End Function

    '=======================
    '  additional developed by LUONG Olivier
    '=======================
    <WebMethod(Description:="This method checks the space use on disk")> Public Function disk_space(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = comma separated utilisation
        '           drive letter list: C,E,F : "c" if none
        '           warning & critical limit in percent : 20,60
        '           ==> C,E,F,60,80
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim obj As Object
            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""
            Dim i As Integer


            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            ' Process parameter
            Dim param_temp As String = param
            If param_temp = "" Then param_temp = "C,60%,80%"

            Dim params() As String = param_temp.Split(",")

            If String.Compare(Strings.Left(params(params.GetUpperBound(0)), 1), "C", True) >= 0 And String.Compare(Strings.Left(params(params.GetUpperBound(0)), 1), "Z", True) <= 0 Then
                ReDim Preserve params(params.GetUpperBound(0) + 2)
                params(params.GetUpperBound(0)) = "80%"
                params(params.GetUpperBound(0) - 1) = "60%"
            End If

            Dim IDX_WARNING As Integer = params.getUpperBound(0) - 1
            Dim IDX_CRITICAL As Integer = params.getUpperBound(0)

            Dim drive(params.getUpperBound(0) - 2) As String
            Dim size(drive.getUpperBound(0)) As Long
            Dim free(drive.getUpperBound(0)) As Long
            Dim used(drive.getUpperBound(0)) As Long
            Dim freepr(drive.getUpperBound(0)) As Integer

            For i = params.GetLowerBound(0) To params.getUpperBound(0) - 2
                drive(i) = Strings.Left(params(i), 1)
                If String.Compare(drive(i), "C", True) >= 0 And String.Compare(drive(i), "Z", True) <= 0 Then
                    size(i) = -1
                    free(i) = 0
                    used(i) = 0
                    freepr(i) = 0
                Else
                    Return drive(i) & " is not a drive letter valid"
                End If
            Next i

            Dim warning_val As Long = 0
            Dim warning_use_pr As Boolean = False

            Try
                warning_val = parsevalue(params(IDX_WARNING), warning_use_pr, 1024L * 1024L)
                If warning_val < 0 Then
                    warning_val = 60
                    warning_use_pr = True
                End If
            Catch e As Exception
                Return "Error converting parameters: " & e.Message
            End Try

            Dim critical_val As Long = 0
            Dim critical_use_pr As Boolean = False

            Try
                critical_val = parsevalue(params(IDX_CRITICAL), critical_use_pr, 1024L * 1024L)
                If critical_val < 0 Then
                    critical_val = 100 - ((100 - warning_val) / 2)
                    critical_use_pr = warning_use_pr
                End If

            Catch e As Exception
                Return "Error converting parameters: " & e.Message
            End Try


            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"

                Return res_str
            Else
                res_str = ""
            End If

            Dim query As String = "Select Name,FreeSpace,Size  FROM Win32_LogicalDisk"


            scope = GetScope("\\" & server & "\root\cimv2", options, ErrString)
            If scope Is Nothing Then Return ErrString
            oq = New System.Management.ObjectQuery(query)
            mos = New System.Management.ManagementObjectSearcher(scope, oq)


            'Dim disk_str As String = ""
            Dim low_space As Boolean = False
            Dim very_low As Boolean = False
            Dim tstr As String = ""

            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility
            ResultStr.AddLine(" ")

            'Dim arQueue As Array = Array.CreateInstance(GetType(String), totalDisk)
            For Each obj In mos.Get()
                If Not IsNothing(obj("Name")) Then
                    Dim letter As String = Strings.Left(obj("Name").ToString, 1).ToUpperInvariant()
                    Dim position As Integer = Array.BinarySearch(drive, letter)
                    If position >= 0 Then
                        If Not IsNothing(obj("size")) Then
                            size(position) = System.Convert.ToDouble(obj("size"))
                            free(position) = System.Convert.ToDouble(obj("freespace"))
                            used(position) = size(position) - free(position)
                            freepr(position) = Format(((100 * free(position)) / size(position)), "standard")
                            If size(position) > 0 Then ' on non-mounted cluster disks: size is zero
                                'tstr = obj("Name") & SizeHumanReadable(free(position)) & "/" & SizeHumanReadable(size(position)) & " (" & freepr & "% free)"
                                tstr = obj("Name") & " " & (100 - freepr(position)) & "%,"

                                If warning_use_pr Then
                                    If (100 - freepr(position)) > warning_val Then
                                        low_space = True
                                        tstr = "<b>" & tstr & "</b>"
                                    End If
                                Else
                                    If size(position) - free(position) > warning_val Then
                                        low_space = True
                                        tstr = "<b>" & tstr & "</b>"
                                    End If
                                End If

                                If critical_use_pr Then
                                    If (100 - freepr(position)) > critical_val Then very_low = True
                                Else
                                    If size(position) - free(position) > critical_val Then very_low = True
                                End If
                                ResultStr.AddText(tstr)

                            End If
                        End If
                        'res_str = res_str & drive(position) & "=" & queue(position) & ","
                        'res_str = res_str & obj("PercentProcessorTime").ToString & "%"
                    Else
                        ' returned null value
                        'res_str = res_str & "<null>"
                    End If
                End If
            Next

            Dim perfdata As String = ""
            Dim unknown As Boolean = False
            For i = drive.GetLowerBound(0) To drive.GetUpperBound(0)
                If size(i) < 0 Then
                    ResultStr.AddText(drive(i) & " is unknown")
                    unknown = True
                Else
                    perfdata = perfdata & "spaceused_" & drive(i).ToLowerInvariant & "=" & used(i) & ";"
                    If warning_use_pr Then
                        'perfdata = perfdata & warning_val
                        perfdata = perfdata & Format(size(i) * warning_val / 100, "0")
                    Else
                        'perfdata = perfdata & Format(((100 * warning_val) / size(i)), "0")
                        perfdata = perfdata & warning_val

                    End If

                    perfdata = perfdata & ";"
                    If critical_use_pr Then
                        perfdata = perfdata & Format(size(i) * critical_val / 100, "0")
                    Else
                        'perfdata = perfdata & Format(((100 * critical_val) / size(i)), "0")
                        perfdata = perfdata & critical_val
                    End If
                    perfdata = perfdata & ";"
                    perfdata = perfdata & "0;" & size(i) & " "

                End If

            Next i

            If Not unknown Then
                ResultStr.AddPerfData(perfdata)
            End If

            If unknown Then
                Return "Result: DRIVE UNKNOWN" + ResultStr.ResultString
            Else
                If very_low Then
                    Return "Result: Disk Critical" + ResultStr.ResultString
                Else
                    If low_space Then
                        Return "Result: Disk Warning" + ResultStr.ResultString
                    Else
                        Return "Result: Disk Okay" + ResultStr.ResultString
                    End If
                End If
            End If
        Catch e As Exception
            Return "Result UNKNOWN: Unhandled exception: " & e.ToString
        End Try
    End Function
    '=====================
    '
    '=====================
#End If


    <WebMethod(Description:="This method checks the uptime of a remote server and flags whether the server has been rebooted recently")> Public Function uptime(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = warning/critical level to use - in Hours

        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)

            'Dim res_str As String = ""
            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility
            ResultStr.AddLine(" ")

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim obj As System.Management.ManagementObject

            Dim lastboot As String = Nothing
            Dim curr_time As String
            Dim dtmlastbootuptime As DateTime, dtmcurrtime As DateTime
            Dim hours_up As Long

            Dim where_str As String = ""
            Dim myarr() As String
            Dim ParamOutOpts() As String
            myarr = param.Split(",")
            ' get output opitons from web.config
            ParamOutOpts = GetOpts("Uptime").Split(",")

            Dim OutOptSmart As Boolean = False
            Dim OptString As String
            '--- First check the wishlist of output Options
            For Each OptString In ParamOutOpts
                If UCase(OptString) = UCase("Smart") Then OutOptSmart = True
            Next

            Dim warning_val As Long = Val(myarr(0))
            If warning_val = -1 Then warning_val = 24
            Dim critical_val As Long = warning_val / 2
            If myarr.GetUpperBound(0) = 1 Then
                critical_val = Val(myarr(1))
            End If

            If debug_flag Then
                ResultStr.AddText("Server: '" & server & "'.....")
                ResultStr.AddText("Param value passed: '" & param & "'.....")
                ResultStr.AddText("warning_value: '" & warning_val & "'(hours).....")
                ResultStr.AddText("critical_value: '" & critical_val & "'(hours).....")
                ResultStr.AddText("WMI username: '" & options.Username & "'.....Notes:")

                If myarr(0) = -1 Then
                    ResultStr.AddText("Warning value defaulted to 24.....")
                End If
                If myarr.GetUpperBound(0) = 0 Then
                    ResultStr.AddText("Critical value defaulted (to half of warning value).....")
                End If
                Return ResultStr.ResultString
            End If

            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2:Win32_OperatingSystem", options, ErrString)
            If scope Is Nothing Then Return ErrString

            oq = New System.Management.ObjectQuery("Select lastbootuptime,localdatetime from Win32_OperatingSystem")
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())

            Dim low As Boolean = False
            Dim very_low As Boolean = False
            For Each obj In mos.Get()
                lastboot = obj("lastbootuptime")
                curr_time = obj("localdatetime")

                If (Not lastboot Is Nothing) Then
                    dtmlastbootuptime = WMIDateStringToDate(lastboot)
                    dtmcurrtime = WMIDateStringToDate(curr_time)
                    hours_up = DateDiff(DateInterval.Hour, dtmlastbootuptime, dtmcurrtime)
                    If hours_up < warning_val Then
                        ResultStr.AddText("<b>")
                        low = True
                    End If
                    If hours_up < critical_val Then very_low = True
                    ResultStr.AddLine("Server up for " & hours_up & " hours")
                    ResultStr.AddLine("Server last booted: " & Format(dtmlastbootuptime, "dd/MM/yyyy HH:mm:ss"))
                    resultstr.AddLine("Current time on server: " & Format(dtmcurrtime, "dd/MM/yyyy HH:mm:ss"))
                    If low Then ResultStr.AddText("</b>")
                End If
            Next

            ResultStr.AddPerfData("uptime=" & hours_up & "h;" & warning_val & ";" & critical_val & ";;")

            If (lastboot Is Nothing) Then
                Return "Result: Uptime Unknown"
            ElseIf very_low Then
                Return "Result: Uptime Critical; " + ResultStr.ResultString
            Else
                If low Then
                    Return "Result: Uptime Warning; " + ResultStr.ResultString
                Else
                    If OutOptSmart Then
                        Return "Result: Uptime Okay;  Up for " & hours_up & " hours|" & ResultStr.Perfdata
                    Else
                        Return "Result: Uptime Okay; " + ResultStr.ResultString
                    End If
                End If
            End If
        Catch e As Exception
            Return "Result UNKNOWN: Unhandled exception: " & e.ToString
        End Try

    End Function

    <WebMethod(Description:="This method checks a list of services to see if any are not running")> Public Function services(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = comma separated list of services to check
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim where_str As String = ""
            Dim ServiceNames() As String
            Dim ParamOutOpts() As String
            ServiceNames = param.Split(",")
            ParamOutOpts = GetOpts("Services").Split(",")

            Dim CheckAllAutoServices As Boolean = False
            If ServiceNames.Length = 1 Then
                If Trim(ServiceNames(0)) = "*" Then CheckAllAutoServices = True
            End If

            ' Output options including their defaults
            ' defaults mimic the behaviour of the original 1.0 version
            Dim OutOptWarnOnMissing As Boolean = False
            Dim OutOptSmart As Boolean = False
            Dim OptString As String
            '--- First check the wishlist of output Options
            For Each OptString In ParamOutOpts
                If UCase(OptString) = UCase("WarnMissing") Then OutOptWarnOnMissing = True
                If UCase(OptString) = UCase("Smart") Then OutOptSmart = True
            Next

            Dim MaxServiceCount As Integer = 0
            If CheckAllAutoServices Then
                where_str = "Select name,state from Win32_Service Where StartMode = 'Auto'"
            Else
                MaxServiceCount = ServiceNames.Length   ' Max is known
                Dim srv As String
                For Each srv In ServiceNames
                    If where_str <> "" Then where_str = where_str + " or "
                    where_str = where_str + "name = '" + Trim(srv) + "'"
                Next
                If where_str = "" Then
                    where_str = "Select name,state from Win32_Service"
                Else
                    where_str = "Select name,state from Win32_Service where " + where_str
                End If
            End If

            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "Selection criteria: '" & where_str & "'....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"

                If param = "" Then
                    res_str = res_str & "All services returned....."
                End If
                Return res_str
            Else
                res_str = ""
            End If

            Dim obj As Object
            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2", options, ErrString)
            If scope Is Nothing Then Return ErrString

            oq = New System.Management.ObjectQuery(where_str)
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())

            Dim StoppedList As String = ""
            Dim RunningList As String = ""

            Dim stopped As Boolean = False
            Dim RunningServiceCount As Integer = 0
            Dim FoundServiceCount As Integer = 0
            For Each obj In mos.Get()
                If LCase(obj("state")) <> "running" Then
                    stopped = True
                    StoppedList = StoppedList + obj("name") + ", "
                ElseIf LCase(obj("state")) = "running" Then
                    RunningList = RunningList + obj("name") + ", "
                    RunningServiceCount = RunningServiceCount + 1
                End If
                FoundServiceCount = FoundServiceCount + 1
            Next
            '-- check for services, which could not be found
            Dim MissingList As String = "", s As String
            If CheckAllAutoServices Then
                MaxServiceCount = FoundServiceCount ' could not been known before
            Else
                For Each s In ServiceNames
                    If InStr(UCase(StoppedList), UCase(s) & ",") <= 0 And InStr(UCase(RunningList), UCase(s) & ",") <= 0 Then
                        MissingList = MissingList & s & ", "
                    End If
                Next
            End If

            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility
            ResultStr.AddLine(RunningServiceCount & " of " & MaxServiceCount & " services running")
            If StoppedList <> "" Then ResultStr.AddLine("Stopped-<b>" & Left(StoppedList, StoppedList.Length - 2) & "</b>")
            If MissingList <> "" Then ResultStr.AddLine("Missing-<b>" & Left(MissingList, MissingList.Length - 2) & "</b>")
            If Not OutOptSmart Then     ' display full output
                If RunningList <> "" Then ResultStr.AddLine("Running-" & Left(RunningList, RunningList.Length - 2))
            End If

            ResultStr.AddPerfData("SvcRunning=" & RunningServiceCount & ";" & MaxServiceCount & ";" & MaxServiceCount & ";;")
            ResultStr.AddPerfData(" SvcFailed=" & MaxServiceCount - RunningServiceCount & ";0;0;;")
            res_str = ResultStr.ResultString

            If stopped Then
                Return "Result: Service(s) Critical; " + res_str
            ElseIf (FoundServiceCount <> MaxServiceCount) And OutOptWarnOnMissing Then
                Return "Result: Service(s) Warning; " + res_str
            Else
                Return "Result: Service(s) Okay; " + res_str
            End If
        Catch e As Exception
            Return "Result UNKNOWN: Unhandled exception: " & e.ToString
        End Try

    End Function

    <WebMethod(Description:="This method checks the CPU utilisation")> Public Function cpu(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = comma separated utilisation
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim param_temp As String = param
            If param_temp = "" Then param_temp = "-1"

            Dim myarr() As String = param_temp.Split(",")
            Dim warning_val As Long = Val(myarr(0))
            Dim critical_val As Long = 60
            If warning_val = -1 Then
                warning_val = 20
            End If
            If myarr.GetUpperBound(0) = 1 Then
                critical_val = Val(myarr(1))
            End If

            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "warning_value: '" & warning_val & "'(hours)....."
                res_str = res_str & "critical_value: '" & critical_val & "'(hours)....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"

                If param_temp = "-1" Then
                    res_str = res_str & "Warning value defaulted to 20....."
                End If
                If myarr.GetUpperBound(0) = 0 Then
                    res_str = res_str & "Critical value defaulted to 60....."
                End If
                Return res_str
            Else
                res_str = ""
            End If

            Dim query As String
            query = "Select LoadPercentage from Win32_Processor"

            Dim obj As Object
            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2", options, ErrString)
            If scope Is Nothing Then Return ErrString
            oq = New System.Management.ObjectQuery(query)
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())

            'Dim Critical As Boolean = False
            'Dim Warning As Boolean = False
            '!!!!!!!!!!!!!!!!!!!!!!!
            '! changed by KT
            '!!!!!!!!!!!!!!!!!!!!!!!


            Dim totalload As Integer = 0
            Dim totalcpu As Integer = 0

            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility

            For Each obj In mos.Get()
                If ResultStr.TextLength > 0 Then ResultStr.AddLine(" ")
                If Not IsNothing(obj("LoadPercentage")) Then
                    totalcpu = totalcpu + 1
                    totalload = totalload + CInt(obj("LoadPercentage").ToString)
                    ResultStr.AddText(obj("LoadPercentage").ToString & "%")
                Else
                    ' returned null value
                    ResultStr.AddText("<null>")
                End If
            Next

            If totalcpu > 1 Then
                totalload = totalload / totalcpu
                ResultStr.AddLine("Average Load: " & totalload & "%")
            End If

            ResultStr.AddPerfData("cpu=" & totalload & "%;" & warning_val & ";" & critical_val & ";;")

            If totalcpu = 0 Then        ' got null for LoadPercentage (e.g. W2K @VMWare)
                Return "Result: CPU UNKNOWN; Load=" + ResultStr.ResultString
            ElseIf totalload > critical_val Then
                Return "Result: CPU(s) Critical; Load=" + ResultStr.ResultString
            ElseIf totalload > warning_val Then
                Return "Result: CPU(s) Warning; Load=" + ResultStr.ResultString
            Else
                Return "Result: CPU(s) Okay; Load=" + ResultStr.ResultString
            End If
        Catch e As Exception
            Return "Result UNKNOWN: Unhandled exception: " & e.ToString
        End Try
    End Function
    <WebMethod(Description:="This method checks the CPU utilisation via Performance-Counter (preview)")> Public Function cpu_perfmon(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = comma separated utilisation
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim param_temp As String = param
            If param_temp = "" Then param_temp = "-1"

            Dim myarr() As String = param_temp.Split(",")
            Dim warning_val As Long = Val(myarr(0))
            Dim critical_val As Long = 60
            If warning_val = -1 Then
                warning_val = 20
            End If
            If myarr.GetUpperBound(0) = 1 Then
                critical_val = Val(myarr(1))
            End If

            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "warning_value: '" & warning_val & "'(hours)....."
                res_str = res_str & "critical_value: '" & critical_val & "'(hours)....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"

                If param_temp = "-1" Then
                    res_str = res_str & "Warning value defaulted to 20....."
                End If
                If myarr.GetUpperBound(0) = 0 Then
                    res_str = res_str & "Critical value defaulted to 60....."
                End If
                Return res_str
            Else
                res_str = ""
            End If

            Dim query As String
            query = "Select PercentIdleTime from Win32_PerfFormattedData_PerfOS_Processor where name=""_Total"""

            Dim obj As Object
            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2", options, ErrString)
            If scope Is Nothing Then Return ErrString
            oq = New System.Management.ObjectQuery(query)
            mos = New System.Management.ManagementObjectSearcher(scope, oq, GetMosOptions())

            Dim totalload As Integer = 0
            Dim totalcpu As Integer = 0
            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility

            For Each obj In mos.Get()
                If ResultStr.TextLength > 0 Then ResultStr.AddLine("")
                If Not IsNothing(obj("PercentIdleTime")) Then
                    totalcpu = totalcpu + 1
                    totalload = totalload + 100 - CInt(obj("PercentIdleTime").ToString)
                    ResultStr.AddText(100 - obj("PercentIdleTime").ToString & "%")
                Else
                    ' returned null value
                    ResultStr.AddText("<null>")
                End If
            Next

            If totalcpu > 1 Then
                totalload = totalload / totalcpu
                ResultStr.AddText(" Average: " & totalload & "%")
            End If

            ResultStr.AddPerfData("cpu=" & totalload & "%;" & warning_val & ";" & critical_val & ";;")

            If totalcpu = 0 Then        ' got null for LoadPercentage (e.g. W2K @VMWare)
                Return "Result: CPU UNKNOWN; Load=" + ResultStr.ResultString
            ElseIf totalload > critical_val Then
                Return "Result: CPU(s) Critical; Load=" + ResultStr.ResultString
            ElseIf totalload > warning_val Then
                Return "Result: CPU(s) Warning; Load=" + ResultStr.ResultString
            Else
                Return "Result: CPU(s) Okay; Load=" + ResultStr.ResultString
            End If
        Catch e As Exception
            Return "Result UNKNOWN: Unhandled exception: " & e.ToString
        End Try
    End Function
    
    	<WebMethod(Description:="This method checks the CPU utilisation with %sys %user")> Public Function cpu_detail(ByVal server As String, ByVal param As String) As String
		' parameters:
        ' server = name of remote server to query
        ' param = comma separated utilisation
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim param_temp As String = param
            If param_temp = "" Then param_temp = "-1"

            Dim myarr() As String = param_temp.Split(",")
            Dim warning_val As Long = Val(myarr(0))
            Dim critical_val As Long = 60
            If warning_val = -1 Then
                warning_val = 20
            End If
            If myarr.GetUpperBound(0) = 1 Then
                critical_val = Val(myarr(1))
            End If

            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "warning_value: '" & warning_val & "'(hours)....."
                res_str = res_str & "critical_value: '" & critical_val & "'(hours)....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"

                If param_temp = "-1" Then
                    res_str = res_str & "Warning value defaulted to 20....."
                End If
                If myarr.GetUpperBound(0) = 0 Then
                    res_str = res_str & "Critical value defaulted to 60....."
                End If
                Return res_str
            Else
                res_str = ""
            End If

            Dim query As String = "Select PercentUserTime,PercentPrivilegedTime,PercentProcessorTime FROM Win32_PerfFormattedData_PerfOS_Processor"

            Dim obj As Object
            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2:Win32_PerfFormattedData_PerfOS_Processor", options, ErrString)
            If scope Is Nothing Then Return ErrString
            oq = New System.Management.ObjectQuery(query)
            mos = New System.Management.ManagementObjectSearcher(scope, oq)

            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility

            Dim totalcpu As Integer = 0
			Dim totaluser As Integer = 0
			Dim totalpriv As Integer = 0
			Dim totalload As Integer = 0

            For Each obj In mos.Get()
                If ResultStr.TextLength > 0 Then ResultStr.AddText("<br>")
                If Not IsNothing(obj("PercentUserTime")) And Not IsNothing(obj("PercentPrivilegedTime")) And Not IsNothing(obj("PercentProcessorTime")) Then
                    totalcpu = totalcpu + 1
                    totalload = totalload + CInt(obj("PercentProcessorTime").ToString)
                    totaluser = totaluser + CInt(obj("PercentUserTime").ToString)
                    totalpriv = totalpriv + CInt(obj("PercentPrivilegedTime").ToString)
                End If
				
            Next

            If totalcpu > 1 Then
                totalload = totalload / totalcpu
				totaluser = totaluser / totalcpu
				totalpriv = totalpriv / totalcpu
                ResultStr.AddLine("CPU(s) Total Load: " & totalload & "%")
                ResultStr.AddLine("User load: " & totaluser & "%")
                ResultStr.AddLine("Priv load: " & totalpriv & "%")
            Else
                ResultStr.AddLine("CPU(s) Total Load: " & totalload & "%")
                ResultStr.AddLine("User load: " & totaluser & "%")
                ResultStr.AddLine("Priv load: " & totalpriv & "%")
            End If

            Dim perfdata As String = ""
            ResultStr.AddPerfData("cpu=" & totalload & "%;" & warning_val & ";" & critical_val & ";;")
            ResultStr.AddPerfData(" cpupriv=" & totalpriv & "%;;;;")
            ResultStr.AddPerfData(" cpuuser=" & totaluser & "%;;;;")

            If totalcpu = 0 Then        ' got null for LoadPercentage (e.g. W2K @VMWare)
                Return "Result: UNKNOWN; " + ResultStr.ResultString
            ElseIf totalload > critical_val Then
                Return "Result: Critical; " + ResultStr.ResultString
            ElseIf totalload > warning_val Then
                Return "Result: Warning; " + ResultStr.ResultString
            Else
                Return "Result: Okay; " + ResultStr.ResultString
            End If
        Catch e As Exception
            Return "Result: UNKNOWN: Unhandled exception: " & e.ToString
        End Try
	End Function

    
    <WebMethod(Description:="This method checks all local volumes of a remote server (including mountpoints) and compares to the threshold value, supplied in megabytes")> Public Function volumes(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = warning/critical level to use - in MEGABYTES,percentage...,alloweddisks

        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim obj As Object
            Dim free As Double
            Dim size As Double

            '!!!!!!!!!!!!!!!!!!!
            '! modified by KT
            '!!!!!!!!!!!!!!!!!!!
            Dim param_temp As String = param
            If param_temp = "" Then param_temp = "-1"
            Dim myarr() As String = param_temp.Split(",")

            Dim warning_val As Long = 20
            Dim warning_use_pr As Boolean = True
            If myarr(0) <> "-1" Then
                warning_val = parsevalue(myarr(0), warning_use_pr, 1024L * 1024L)
            End If

            Dim critical_val As Long = warning_val / 2
            Dim critical_use_pr As Boolean = True
            Dim UseAsExceptList As Boolean = False
            Dim allowed_disks As String = ""
            Try
                If myarr.GetUpperBound(0) > 0 Then  ' 2nd param is entered
                    critical_val = parsevalue(myarr(1), critical_use_pr, 1024L * 1024L)
                End If
                If myarr.GetUpperBound(0) > 1 Then  ' 3rd param is entered
                    If Left(myarr(2), 8) = "exclude:" Then
                        UseAsExceptList = True
                        myarr(2) = myarr(2).Substring(8, Len(myarr(2)) - 8)
                    End If
                    allowed_disks = myarr(2)
                End If
                '!!!!!!!!!!!!!!!!!!            If param_temp = "" Then param_temp = "-1"
            Catch e As Exception
                Return "Error converting parameters: " & e.Message
            End Try
            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "warning_value: '" & warning_val & "'(bytes)....."
                res_str = res_str & "critical_value: '" & critical_val & "'(bytes)....."
                res_str = res_str & "disks for check: '" & allowed_disks & "'....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"

                If myarr(0) = -1 Then
                    res_str = res_str & "Warning value defaulted to 1MB....."
                End If
                If myarr.GetUpperBound(0) = 0 Then
                    res_str = res_str & "Critical value defaulted (to half of warning value)....."
                End If
                Return res_str
            Else
                res_str = ""
            End If

            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\cimv2:Win32_Volume", options, ErrString)
            If scope Is Nothing Then Return ErrString
            oq = New System.Management.ObjectQuery("Select caption,capacity,freespace from Win32_Volume where drivetype = 3")

            mos = New System.Management.ManagementObjectSearcher(scope, oq)
            '   Dim output As String = ""
            'Dim disk_str As String = ""
            Dim ResultStr As New Nagios3Multiline
            ResultStr.Nagios3Compatibility = Me.Nagios3Compatibility
            ResultStr.AddText(" ")

            Dim low_space As Boolean = False
            Dim very_low As Boolean = False
            '  Dim i_threshold As Long
            '  i_threshold = Val(param) * 1024 * 1024 ' convert megabytes to bytes
            '!!!!!!!!!!!!!!!!!!!!!!!
            '! modified by KT
            '!!!!!!!!!!!!!!!!!!!!!!!
            Dim allowed_disks_arr As Array = Nothing
            Dim disk_proceed As Boolean
            Dim freepr As Integer
            Dim Cnt As Integer
            If allowed_disks <> "" Then allowed_disks_arr = Split(allowed_disks, "|")
            Dim tstr As String
            For Each obj In mos.Get()
                disk_proceed = True
                If allowed_disks <> "" Then
                    If UseAsExceptList Then
                        If Array.IndexOf(allowed_disks_arr, obj("caption")) <> -1 Then disk_proceed = False
                    Else
                        If Array.IndexOf(allowed_disks_arr, obj("caption")) = -1 Then disk_proceed = False
                    End If
                End If
                If disk_proceed = True Then
                    Cnt = Cnt + 1
                    size = System.Convert.ToDouble(obj("capacity"))
                    free = System.Convert.ToDouble(obj("freespace"))

                    If size > 0 Then ' on non-mounted cluster disks: size is zero
                        freepr = Format(((100 * free) / size), "standard")
                        'If ResultStr.TextLength > 0 Then ResultStr.AddText("<br>")

                        tstr = obj("caption") & SizeHumanReadable(free) & "/" & SizeHumanReadable(size) & " (" & freepr & "% free)"

                        If warning_use_pr Then
                            If freepr < warning_val Then
                                low_space = True
                                tstr = "<b>" & tstr & "</b>"
                            End If
                        Else
                            If free < warning_val Then
                                low_space = True
                                tstr = "<b>" & tstr & "</b>"
                            End If
                        End If

                        If critical_use_pr Then
                            If freepr < critical_val Then very_low = True
                        Else
                            If free < critical_val Then very_low = True
                        End If

                        ResultStr.AddLine(tstr)
                    End If
                End If
            Next

            If very_low Then
                Return "Result: Volume(s) Critical; " + ResultStr.ResultString
            Else
                If low_space Then
                    Return "Result: Volume(s) Warning; " + ResultStr.ResultString
                ElseIf Cnt = 0 Then
                    Return "Result: Unknown: No volumes to check!"
                Else
                    Return "Result: Volume(s) Okay; " + ResultStr.ResultString
                End If
            End If

        Catch e As Exception
            Return "Result UNKNOWN: Unhandled exception: " & e.ToString
        End Try

    End Function
    <WebMethod(Description:="This method checks the number of messages in Exchange Queues")> Public Function exch_smtpqueues(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        '   warning, critical: count of messages allowed
        ' defaults: : 0,0
        ' ...... Remark: Windows2000 WMI does not support LIKE operator => no star convention supported!

        Dim ReturnCode As Integer = RET_UNKNOWN
        Dim ReturnMsg As String = ""
        Try
            Dim oq As System.Management.ObjectQuery
            Dim mos As System.Management.ManagementObjectSearcher
            Dim options As System.Management.ConnectionOptions = get_auth(server)
            Dim res_str As String = ""

            Dim debug_flag As Boolean = False
            check_debug(server, debug_flag)

            Dim obj As Object
            Const IDX_WARN As Integer = 0
            Const IDX_CRIT As Integer = 1

            Dim param_temp As String = param
            If param_temp = "" Then param_temp = "0,0"
            Dim myarr() As String = param_temp.Split(",")

            Dim warning_val As Integer
            Dim critical_val As Integer
            Dim dummy_pr As Integer
            Dim ServerName As String = ""
            Try
                warning_val = parsevalue(myarr(IDX_WARN), dummy_pr, 1)
                critical_val = parsevalue(myarr(IDX_CRIT), dummy_pr, 1)
                If critical_val = 0 Then critical_val = warning_val
            Catch e As Exception
                Return "Error converting parameters: " & e.Message
            End Try

            If debug_flag Then
                res_str = res_str & "Server: '" & server & "'....."
                res_str = res_str & "Param value passed: '" & param & "'....."
                res_str = res_str & "warning_value: '" & warning_val & "')....."
                res_str = res_str & "critical_val: '" & critical_val & "')....."
                res_str = res_str & "WMI username: '" & options.Username & "'.....Notes:"
                Return res_str
            Else
                res_str = ""
            End If

            Dim scope As System.Management.ManagementScope
            Dim ErrString As String = ""
            scope = GetScope("\\" & server & "\root\MicrosoftExchangeV2:Exchange_SMTPQueue", options, ErrString)
            If scope Is Nothing Then Return ErrString

            oq = New System.Management.ObjectQuery("Select * from Exchange_SMTPQueue")

            mos = New System.Management.ManagementObjectSearcher(scope, oq)
            ReturnCode = RET_OK
            Dim QueueSize As Integer = 0
            Dim QueueName As String = ""
            For Each obj In mos.Get()
                QueueName = obj("LinkName")
                'Return QueueName
                QueueSize = obj("MessageCount")
                ReturnMsg = ReturnMsg & QueueName & " contains " & QueueSize & " messages."
            Next

            If QueueSize > warning_val Then ReturnCode = RET_WARN
            If QueueSize > critical_val Then ReturnCode = RET_CRIT
            Select Case ReturnCode
                Case RET_OK
                    ReturnMsg = "OK; " & ReturnMsg
                Case RET_WARN
                    ReturnMsg = "WARNING; " & ReturnMsg
                Case RET_CRIT
                    ReturnMsg = "CRITICAL: " & ReturnMsg
                Case RET_UNKNOWN
                    ReturnMsg = "UNKNOWN: " & ReturnMsg
            End Select

        Catch e As Exception
            Return "Return UNKNOWN: Unhandled exception: " & e.ToString & ". What's wrong?"
        End Try
        Return "Result: " & ReturnMsg
    End Function
    <WebMethod(Description:="This method acts like a wmi proxy")> Public Function generic_WMI(ByVal server As String, ByVal WMI_Class As String, ByVal Select_Fields As String, ByVal Where_clause As String) As System.Xml.XmlDocument

        ' parameters:
        ' server = name of remote server to query
        ' WMI_Class = Which WMI_Class to parse
        ' 
        Dim username As String = ""
        Dim password As String = ""

        Dim in_WMI_Fields As String = Select_Fields
        If in_WMI_Fields = "" Then in_WMI_Fields = "*"

        Dim in_WMI_Class As String = WMI_Class
        If in_WMI_Class = "" Then in_WMI_Class = "Win32_LogicalDisk"
        Dim in_where As String = Where_clause

        Dim select_sql As String = "SELECT " + in_WMI_Fields + " FROM " + in_WMI_Class
        If in_where <> "" Then
            select_sql = select_sql + " WHERE " + in_where
        End If
        get_auth(server, username, password)
        Dim strComputer As String = server
        Dim XMLdoc As New System.Xml.XmlDocument
        Dim XMLRoot, NewNode, MemNode, Propnode
        Dim Prop
        Dim objSWbemLocator = CreateObject("WbemScripting.SWbemLocator")
        Dim objSWbemServices
        Dim Members

        If Not valid_caller() Then
            Return xml_error("Caller's IP address is not permitted access - " + Me.Context.Request.UserHostAddress, in_WMI_Class)
        End If
        If Not valid_call(in_WMI_Class) Then
            Return xml_error("WMI Class attempted is not currently permitted - " + in_WMI_Class, in_WMI_Class)
        End If
        Try
            If username = "" And password = "" Then
                objSWbemServices = objSWbemLocator.ConnectServer(strComputer, "root\cimv2")     ' Try app-pool identity
            Else
                objSWbemServices = objSWbemLocator.ConnectServer(strComputer, "root\cimv2", username, password)
            End If
            Members = objSWbemServices.ExecQuery(select_sql)
        Catch e As System.Runtime.InteropServices.COMException
            If Left(e.Message, 40) = "User credentials cannot be used for loca" Then
                '                     1234567890123456789012345678901234567890
                in_WMI_Fields = e.Message
                Members = Nothing
                objSWbemServices = Nothing
                objSWbemServices = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & server & "\root\cimv2")
                Members = objSWbemServices.ExecQuery(select_sql)
            Else
                'XMLdoc.LoadXml("<" & in_WMI_Class & "_Members/>")
                'XMLRoot = XMLdoc.SelectSingleNode(in_WMI_Class & "_Members")
                'NewNode = XMLdoc.CreateElement(in_WMI_Class)
                'MemNode = XMLRoot.AppendChild(NewNode)
                'NewNode = XMLdoc.CreateElement("Error")
                'Propnode = MemNode.AppendChild(NewNode)
                'Propnode.SetAttribute("Value", e.Message)
                Return xml_error(e.Message, in_WMI_Class)
            End If
        End Try
        Dim Member

        Dim res_str As String = ""

        XMLdoc.LoadXml("<" & in_WMI_Class & "_Members/>")
        XMLRoot = XMLdoc.SelectSingleNode(in_WMI_Class & "_Members")

        For Each Member In Members

            NewNode = XMLdoc.CreateElement(in_WMI_Class)
            MemNode = XMLRoot.AppendChild(NewNode)
            For Each Prop In Member.Properties_
                NewNode = XMLdoc.CreateElement(Prop.Name)
                If Not IsNothing(Prop.Value) Then
                    Propnode = MemNode.AppendChild(NewNode)
                    If IsArray(Prop.Value) Then
                        Propnode.SetAttribute("Value", Join(Prop.Value, ",") & ")")
                    Else
                        Propnode.SetAttribute("Value", Prop.Value.ToString)
                    End If
                End If
            Next
        Next
        'res_str = XMLdoc
        Return XMLdoc
    End Function
    Private Function xml_error(ByVal in_message As String, ByVal in_class As String) As System.Xml.XmlDocument
        Dim xmldoc As New System.Xml.XmlDocument
        Dim XMLRoot, NewNode, MemNode, Propnode

        xmldoc.LoadXml("<" & in_class & "_Members/>")
        XMLRoot = xmldoc.SelectSingleNode(in_class & "_Members")
        NewNode = xmldoc.CreateElement(in_class)
        MemNode = XMLRoot.AppendChild(NewNode)
        NewNode = xmldoc.CreateElement("Error")
        Propnode = MemNode.AppendChild(NewNode)
        Propnode.SetAttribute("Value", in_message)
        Return xmldoc
    End Function
    Private Function GetOpts(ByVal ServiceName As String) As String
        Try
            GetOpts = GetAppSetting(ServiceName & "Options")
            If GetOpts Is Nothing Then GetOpts = ""
        Catch e As Exception
            GetOpts = ""
        End Try
    End Function
    Private Function valid_caller() As Boolean

        Dim caller_ip As String = Me.Context.Request.UserHostAddress
        Dim ret_val As Boolean = False

        Dim ip_list As String = GetAppSetting("valid_callers")
        Dim valid_ip_arr() As String = ip_list.Split(",")
        ' should now have an array of valid caller IP addresses
        Dim i As Integer
        For i = 0 To valid_ip_arr.GetUpperBound(0)
            If caller_ip = valid_ip_arr(i) Then
                'caller allowed
                ret_val = True
            End If
        Next

        caller_ip = Nothing
        ip_list = Nothing
        valid_ip_arr = Nothing
        Return ret_val

    End Function
    Private Function valid_call(ByVal in_call As String) As Boolean

        Dim ret_val As Boolean = False

        Dim call_list As String = GetAppSetting("valid_calls")
        Dim valid_call_arr() As String = call_list.Split(",")
        ' should now have an array of valid calls we can make
        Dim i As Integer
        For i = 0 To valid_call_arr.GetUpperBound(0)
            If in_call.ToLower = valid_call_arr(i).ToLower Then
                'call allowed
                ret_val = True
            End If
        Next

        call_list = Nothing
        valid_call_arr = Nothing
        Return ret_val

    End Function
    Private Function get_auth(ByRef server As String) As System.Management.ConnectionOptions
        Dim i As Integer
        Dim strDomain As String = ""

        get_auth = Nothing
        'look for auth string for current server
        ' experimental: if server="<domain>\<server>" first check for "server", then "dom:<domain>", then default
        Dim auth_string As String = GetAppSetting(server)

        If auth_string = "" Then    ' check if server contains a domain-part
            Dim idx As Integer
            idx = server.IndexOf("\")
            If idx > 0 Then
                strDomain = Left(server, idx)
                server = server.Substring(idx + 1)
                auth_string = GetAppSetting("dom:" & strDomain)
            End If
        End If

        If auth_string = "" Then ' no alternative password defined, fall back to default
            auth_string = GetAppSetting("default_auth")
        End If
        ' if no new default, map older style (username, password) to username:password
        ' this is easier to maintain
        If auth_string = "" Then
            Dim a, b As String
            a = GetAppSetting("sysusername")
            b = GetAppSetting("syspassword")
            If a <> "" And b <> "" Then auth_string = a & ":" & b
        End If

        ' now should be in form: username:password or domain/username:password or username@domain:password
        ' or empty for using "current process identity"
        Dim options As New System.Management.ConnectionOptions
        If auth_string = "" Then Return options
        i = InStr(auth_string, ":")
        If i < 2 Then
            Throw New Exception("Invalid authentication string '" & auth_string & "'; must be 'user:password'")
        End If

        options.Password = Mid(auth_string, i + 1)
        auth_string = Left(auth_string, i - 1)
        options.Username = auth_string
        Return options
    End Function
    Private Sub get_auth(ByVal server As String, ByRef username As String, ByRef password As String)
        Call get_auth_data(server, username, password)
    End Sub
    Private Sub get_auth_data(ByVal server As String, ByRef username As String, ByRef password As String)
        Dim i As Integer
        Dim strDomain As String = ""

        'look for auth string for current server
        ' experimental: if server="<domain>\<server>" first check for "server", then "dom:<domain>", then default
        Dim auth_string As String = GetAppSetting(server)

        If auth_string = "" Then    ' check if server contains a domain-part
            Dim idx As Integer
            idx = server.IndexOf("\")
            If idx > 0 Then
                strDomain = Left(server, idx)
                server = server.Substring(idx + 1)
                auth_string = GetAppSetting("dom:" & strDomain)
            End If
        End If

        If auth_string = "" Then ' no alternative password defined, fall back to default
            auth_string = GetAppSetting("default_auth")
        End If
        ' if no new default, map older style (username, password) to username:password
        ' this is easier to maintain
        If auth_string = "" Then
            Dim a, b As String
            a = GetAppSetting("sysusername")
            b = GetAppSetting("syspassword")
            If a <> "" And b <> "" Then auth_string = a & ":" & b
        End If

        ' now should be in form: username:password or domain/username:password or username@domain:password
        ' or empty for using "current process identity"
        If auth_string = "" Then Return
        i = InStr(auth_string, ":")
        If i < 2 Then
            Throw New Exception("Invalid authentication string '" & auth_string & "'; must be 'user:password'")
        End If

        password = Mid(auth_string, i + 1)
        auth_string = Left(auth_string, i - 1)
        username = auth_string
    End Sub
    ' to prepare for .NET 2.0 "System.Configuration.ConfigurationSettings.AppSettings" is obsolete
#If VS2003 Then
    Private Function GetAppSetting(ByVal key As String) As String
        Return System.Configuration.ConfigurationSettings.AppSettings(key)
    End Function
#Else
    Private Function GetAppSetting(ByVal key As String) As String
        Return System.Configuration.ConfigurationManager.AppSettings(key)
    End Function
#End If
    Private Function SizeHumanReadable(ByVal val As Double) As String
        '--- did not find a better solution :-(
        ' Creates and initializes a CultureInfo.
        Dim myCI As New System.Globalization.CultureInfo("en-US", False)
        ' modify the number format (necessary for displaying correct numbers in perfdata)
        ' but keeps all other localized settings
        Dim myCIclone As System.Globalization.CultureInfo = CType(System.Threading.Thread.CurrentThread.CurrentCulture.Clone(), System.Globalization.CultureInfo)
        myCIclone.NumberFormat.NumberDecimalSeparator = "."
        myCIclone.NumberFormat.NumberGroupSeparator = ","
        System.Threading.Thread.CurrentThread.CurrentCulture = myCIclone
        '
        If val > (1024L * 1024L * 1024L) Then Return Format((val / (1024L * 1024L * 1024L)), "standard") & "GB"
        If val > (1024L * 1024L) Then Return Format((val / (1024L * 1024L)), "standard") & "MB"
        If val > (1024L) Then Return Format((val / (1024L)), "standard") & "KB"
        Return Format(val, "standard") & "B"
    End Function

    Private Function WMIDateStringToDate(ByVal dtmBootup As String) As DateTime
        WMIDateStringToDate = CDate(Microsoft.VisualBasic.Left(dtmBootup, 4) & "/" & _
             Mid(dtmBootup, 5, 2) & "/" & _
             Mid(dtmBootup, 7, 2) & _
             " " & Mid(dtmBootup, 9, 2) & ":" & _
             Mid(dtmBootup, 11, 2) & ":" & Mid(dtmBootup, _
             13, 2))
    End Function
    Private Sub check_debug(ByRef server As String, ByRef DebugFlag As Boolean)
        DebugFlag = False
        If LCase(Left(server, 6)) = "debug*" Then
            DebugFlag = True
            server = Mid(server, 7)
        End If
    End Sub

    Private Function GetScope(ByVal MgmtPath As String, ByVal options As System.Management.ConnectionOptions, ByRef ErrString As String) _
           As System.Management.ManagementScope

        Dim sc As New System.Management.ManagementScope(MgmtPath, options)
        ErrString = ""
        Try
            sc.Connect()
        Catch e As System.Management.ManagementException
            ' catch if checking local machine - credentials not required()
            If e.ErrorCode = System.Management.ManagementStatus.LocalCredentials Then
                sc = Nothing
                sc = New System.Management.ManagementScope(MgmtPath)
            Else
                ErrString = "Result Critical: Connect error, code=" & e.ErrorCode & "; msg=" & e.Message()
                sc = Nothing
            End If
        Catch e As Exception
            sc = Nothing
            ErrString = "Result Unknown: Unknown exception connecting scope(servername invalid?)<br>" & e.Message
        End Try
        Return sc
    End Function
    Private Function GetMosOptions() As System.Management.EnumerationOptions
        Dim EnumOpt As New System.Management.EnumerationOptions
        EnumOpt.Rewindable = False
        EnumOpt.ReturnImmediately = True
        ' Limit the time for retrieving the data (calls to Get & MoveNext!)
        Dim Timeout As Integer = CInt(GetAppSetting("QueryTimeout"))
        If Timeout = 0 Then Timeout = DEF_QUERY_TIMEOUT
        If Timeout > 0 Then
            EnumOpt.Timeout = New TimeSpan(0, 0, 0, Timeout)
        End If
        Return EnumOpt
    End Function
    Private Function splitforquery(ByVal aparam As String, ByVal afield As String) As String
        Dim arrel, tempWhere As String
        Dim arr As Array
        tempWhere = ""
        arr = Split(aparam, "|")
        For Each arrel In arr
            If tempWhere <> "" Then tempWhere = tempWhere & " Or "
            tempWhere = tempWhere & afield & "='" & arrel & "'"
        Next
        Return tempWhere
    End Function

    Private Function nteventdatetime(ByRef adate As DateTime) As String
        Dim tstr2, tstr3 As String
        tstr2 = Year(adate)
        tstr3 = Month(adate)
        If Len(tstr3) = 1 Then tstr2 = tstr2 + "0" + tstr3 Else tstr2 = tstr2 + tstr3
        tstr3 = Day(adate)
        If Len(tstr3) = 1 Then tstr2 = tstr2 + "0" + tstr3 Else tstr2 = tstr2 + tstr3
        tstr3 = Hour(adate)
        If Len(tstr3) = 1 Then tstr2 = tstr2 + "0" + tstr3 Else tstr2 = tstr2 + tstr3
        tstr3 = Minute(adate)
        If Len(tstr3) = 1 Then tstr2 = tstr2 + "0" + tstr3 Else tstr2 = tstr2 + tstr3
        tstr3 = Second(adate)
        If Len(tstr3) = 1 Then tstr2 = tstr2 + "0" + tstr3 Else tstr2 = tstr2 + tstr3
        Return tstr2 & ".000000+000"
    End Function

    Private Function parsevalue(ByVal value As String, ByRef ispercents As Boolean, ByVal DefaultMultiplier As Long) As Long
        ispercents = False
        If Right(value, 1) = "%" Then
            ispercents = True
            Return CLng(Left(value, Len(value) - 1))
        ElseIf Right(value, 1) = "k" Then
            Return CLng(Left(value, Len(value) - 1)) * 1000L
        ElseIf Right(value, 1) = "K" Then
            Return CLng(Left(value, Len(value) - 1)) * 1024L
        ElseIf Right(value, 1) = "M" Then
            Return CLng(Left(value, Len(value) - 1)) * 1024L * 1024L
        ElseIf Right(value, 1) = "G" Then
            Return CLng(Left(value, Len(value) - 1)) * 1024L * 1024L * 1024L
        Else
            Return CLng(value * DefaultMultiplier)
        End If
    End Function

    Private Function parseFileName(ByVal FileName As String, ByRef ServerName As String, ByRef ShareName As String, ByRef DriveLetter As String, ByRef Path As String, ByRef BaseName As String, ByRef Extension As String) As Boolean
        Dim idx As Integer
        ServerName = ""
        DriveLetter = ""
        Path = ""
        BaseName = ""
        Extension = ""

        FileName.Trim()
        If FileName.StartsWith("\\") Then
            FileName = FileName.Remove(0, 2)        ' remove backslashes
            idx = FileName.IndexOf("\")
            ServerName = FileName.Substring(0, idx)
            FileName = FileName.Substring(idx + 1)
            idx = FileName.IndexOf("\")
            ShareName = FileName.Substring(0, idx)
            FileName = FileName.Substring(idx + 1)
        ElseIf FileName.IndexOf(":") > 0 Then
            DriveLetter = Left(FileName, 1)
            FileName = FileName.Substring(FileName.IndexOf(":") + 1)
        End If
        ' if a UNC was given, Server and Share are now deleted
        If FileName.EndsWith("\") Then
            Path = FileName
        Else
            idx = FileName.LastIndexOf("\")
            Path = FileName.Substring(0, idx + 1)
            FileName = FileName.Substring(idx + 1)
            idx = FileName.LastIndexOf(".")
            If idx > 0 Then
                BaseName = Left(FileName, idx)
                Extension = FileName.Substring(idx + 1)
            Else
                BaseName = FileName
            End If
        End If
        Return True
    End Function
    Private Function ParseTimeDiff(ByVal s As String, ByVal def As DateTime) As DateTime
        Dim Value As Integer
        If s = "" Then Return def
        Value = Val(s)
        Select Case (Right(s, 1))
            Case "m"
                Return Now().AddMinutes(-Value)
            Case "h"
                Return Now().AddHours(-Value)
            Case "d"
                Return Now().AddDays(-Value)
            Case Else
                Throw New Exception("Invalid timecode ([m|h|d])")
        End Select
    End Function
End Class
